"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.visitAsync = exports.visit = exports.stringify = exports.parseDocument = exports.parseAllDocuments = exports.parse = exports.isSeq = exports.isScalar = exports.isPair = exports.isNode = exports.isMap = exports.isDocument = exports.isCollection = exports.isAlias = exports.default = exports.YAMLWarning = exports.YAMLSeq = exports.YAMLParseError = exports.YAMLMap = exports.YAMLError = exports.Schema = exports.Scalar = exports.Parser = exports.Pair = exports.LineCounter = exports.Lexer = exports.Document = exports.Composer = exports.CST = exports.Alias = void 0;
/* esm.sh - esbuild bundle(yaml@2.2.1) es2022 production */
const node_process_js_1 = __importDefault(require("../../node_process.js"));
const node_buffer_js_1 = require("../../node_buffer.js");
var an = Object.defineProperty;
var Dt = (s, e) => { for (var t in e)
    an(s, t, { get: e[t], enumerable: !0 }); };
var Bt = {};
Dt(Bt, { Alias: () => G, CST: () => _t, Composer: () => ge, Document: () => R, Lexer: () => Ae, LineCounter: () => Oe, Pair: () => I, Parser: () => be, Scalar: () => S, Schema: () => ce, YAMLError: () => ke, YAMLMap: () => v, YAMLParseError: () => x, YAMLSeq: () => _, YAMLWarning: () => Ne, default: () => Vn, isAlias: () => K, isCollection: () => T, isDocument: () => re, isMap: () => M, isNode: () => L, isPair: () => E, isScalar: () => A, isSeq: () => q, parse: () => as, parseAllDocuments: () => os, parseDocument: () => Mt, stringify: () => ls, visit: () => F, visitAsync: () => Ie });
var cs = {};
Dt(cs, { Alias: () => G, CST: () => _t, Composer: () => ge, Document: () => R, Lexer: () => Ae, LineCounter: () => Oe, Pair: () => I, Parser: () => be, Scalar: () => S, Schema: () => ce, YAMLError: () => ke, YAMLMap: () => v, YAMLParseError: () => x, YAMLSeq: () => _, YAMLWarning: () => Ne, isAlias: () => K, isCollection: () => T, isDocument: () => re, isMap: () => M, isNode: () => L, isPair: () => E, isScalar: () => A, isSeq: () => q, parse: () => as, parseAllDocuments: () => os, parseDocument: () => Mt, stringify: () => ls, visit: () => F, visitAsync: () => Ie });
var Ze = Symbol.for("yaml.alias"), et = Symbol.for("yaml.document"), Q = Symbol.for("yaml.map"), jt = Symbol.for("yaml.pair"), V = Symbol.for("yaml.scalar"), ie = Symbol.for("yaml.seq"), D = Symbol.for("yaml.node.type"), K = s => !!s && typeof s == "object" && s[D] === Ze, re = s => !!s && typeof s == "object" && s[D] === et, M = s => !!s && typeof s == "object" && s[D] === Q, E = s => !!s && typeof s == "object" && s[D] === jt, A = s => !!s && typeof s == "object" && s[D] === V, q = s => !!s && typeof s == "object" && s[D] === ie;
function T(s) { if (s && typeof s == "object")
    switch (s[D]) {
        case Q:
        case ie: return !0;
    } return !1; }
function L(s) { if (s && typeof s == "object")
    switch (s[D]) {
        case Ze:
        case Q:
        case V:
        case ie: return !0;
    } return !1; }
var us = s => (A(s) || T(s)) && !!s.anchor, fe = class {
    constructor(e) { Object.defineProperty(this, D, { value: e }); }
    clone() { let e = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this)); return this.range && (e.range = this.range.slice()), e; }
};
var j = Symbol("break visit"), hs = Symbol("skip children"), ee = Symbol("remove node");
function F(s, e) { let t = ps(e); re(s) ? Le(null, s.contents, t, Object.freeze([s])) === ee && (s.contents = null) : Le(null, s, t, Object.freeze([])); }
F.BREAK = j;
F.SKIP = hs;
F.REMOVE = ee;
function Le(s, e, t, n) { let i = ms(s, e, t, n); if (L(i) || E(i))
    return ds(s, n, i), Le(s, i, t, n); if (typeof i != "symbol") {
    if (T(e)) {
        n = Object.freeze(n.concat(e));
        for (let r = 0; r < e.items.length; ++r) {
            let o = Le(r, e.items[r], t, n);
            if (typeof o == "number")
                r = o - 1;
            else {
                if (o === j)
                    return j;
                o === ee && (e.items.splice(r, 1), r -= 1);
            }
        }
    }
    else if (E(e)) {
        n = Object.freeze(n.concat(e));
        let r = Le("key", e.key, t, n);
        if (r === j)
            return j;
        r === ee && (e.key = null);
        let o = Le("value", e.value, t, n);
        if (o === j)
            return j;
        o === ee && (e.value = null);
    }
} return i; }
async function Ie(s, e) { let t = ps(e); re(s) ? await Te(null, s.contents, t, Object.freeze([s])) === ee && (s.contents = null) : await Te(null, s, t, Object.freeze([])); }
Ie.BREAK = j;
Ie.SKIP = hs;
Ie.REMOVE = ee;
async function Te(s, e, t, n) { let i = await ms(s, e, t, n); if (L(i) || E(i))
    return ds(s, n, i), Te(s, i, t, n); if (typeof i != "symbol") {
    if (T(e)) {
        n = Object.freeze(n.concat(e));
        for (let r = 0; r < e.items.length; ++r) {
            let o = await Te(r, e.items[r], t, n);
            if (typeof o == "number")
                r = o - 1;
            else {
                if (o === j)
                    return j;
                o === ee && (e.items.splice(r, 1), r -= 1);
            }
        }
    }
    else if (E(e)) {
        n = Object.freeze(n.concat(e));
        let r = await Te("key", e.key, t, n);
        if (r === j)
            return j;
        r === ee && (e.key = null);
        let o = await Te("value", e.value, t, n);
        if (o === j)
            return j;
        o === ee && (e.value = null);
    }
} return i; }
function ps(s) { return typeof s == "object" && (s.Collection || s.Node || s.Value) ? Object.assign({ Alias: s.Node, Map: s.Node, Scalar: s.Node, Seq: s.Node }, s.Value && { Map: s.Value, Scalar: s.Value, Seq: s.Value }, s.Collection && { Map: s.Collection, Seq: s.Collection }, s) : s; }
function ms(s, e, t, n) { if (typeof t == "function")
    return t(s, e, n); if (M(e))
    return t.Map?.(s, e, n); if (q(e))
    return t.Seq?.(s, e, n); if (E(e))
    return t.Pair?.(s, e, n); if (A(e))
    return t.Scalar?.(s, e, n); if (K(e))
    return t.Alias?.(s, e, n); }
function ds(s, e, t) { let n = e[e.length - 1]; if (T(n))
    n.items[s] = t;
else if (E(n))
    s === "key" ? n.key = t : n.value = t;
else if (re(n))
    n.contents = t;
else {
    let i = K(n) ? "alias" : "scalar";
    throw new Error(`Cannot replace node with ${i} parent`);
} }
var ln = { "!": "%21", ",": "%2C", "[": "%5B", "]": "%5D", "{": "%7B", "}": "%7D" }, cn = s => s.replace(/[!,[\]{}]/g, e => ln[e]), $ = class {
    constructor(e, t) { this.docStart = null, this.docEnd = !1, this.yaml = Object.assign({}, $.defaultYaml, e), this.tags = Object.assign({}, $.defaultTags, t); }
    clone() { let e = new $(this.yaml, this.tags); return e.docStart = this.docStart, e; }
    atDocument() { let e = new $(this.yaml, this.tags); switch (this.yaml.version) {
        case "1.1":
            this.atNextDocument = !0;
            break;
        case "1.2":
            this.atNextDocument = !1, this.yaml = { explicit: $.defaultYaml.explicit, version: "1.2" }, this.tags = Object.assign({}, $.defaultTags);
            break;
    } return e; }
    add(e, t) { this.atNextDocument && (this.yaml = { explicit: $.defaultYaml.explicit, version: "1.1" }, this.tags = Object.assign({}, $.defaultTags), this.atNextDocument = !1); let n = e.trim().split(/[ \t]+/), i = n.shift(); switch (i) {
        case "%TAG": {
            if (n.length !== 2 && (t(0, "%TAG directive should contain exactly two parts"), n.length < 2))
                return !1;
            let [r, o] = n;
            return this.tags[r] = o, !0;
        }
        case "%YAML": {
            if (this.yaml.explicit = !0, n.length !== 1)
                return t(0, "%YAML directive should contain exactly one part"), !1;
            let [r] = n;
            if (r === "1.1" || r === "1.2")
                return this.yaml.version = r, !0;
            {
                let o = /^\d+\.\d+$/.test(r);
                return t(6, `Unsupported YAML version ${r}`, o), !1;
            }
        }
        default: return t(0, `Unknown directive ${i}`, !0), !1;
    } }
    tagName(e, t) { if (e === "!")
        return "!"; if (e[0] !== "!")
        return t(`Not a valid tag: ${e}`), null; if (e[1] === "<") {
        let o = e.slice(2, -1);
        return o === "!" || o === "!!" ? (t(`Verbatim tags aren't resolved, so ${e} is invalid.`), null) : (e[e.length - 1] !== ">" && t("Verbatim tags must end with a >"), o);
    } let [, n, i] = e.match(/^(.*!)([^!]*)$/); i || t(`The ${e} tag has no suffix`); let r = this.tags[n]; return r ? r + decodeURIComponent(i) : n === "!" ? e : (t(`Could not resolve tag: ${e}`), null); }
    tagString(e) { for (let [t, n] of Object.entries(this.tags))
        if (e.startsWith(n))
            return t + cn(e.substring(n.length)); return e[0] === "!" ? e : `!<${e}>`; }
    toString(e) {
        let t = this.yaml.explicit ? [`%YAML ${this.yaml.version || "1.2"}`] : [], n = Object.entries(this.tags), i;
        if (e && n.length > 0 && L(e.contents)) {
            let r = {};
            F(e.contents, (o, a) => { L(a) && a.tag && (r[a.tag] = !0); }), i = Object.keys(r);
        }
        else
            i = [];
        for (let [r, o] of n)
            r === "!!" && o === "tag:yaml.org,2002:" || (!e || i.some(a => a.startsWith(o))) && t.push(`%TAG ${r} ${o}`);
        return t.join(`
`);
    }
};
$.defaultYaml = { explicit: !1, version: "1.2" };
$.defaultTags = { "!!": "tag:yaml.org,2002:" };
function tt(s) { if (/[\x00-\x19\s,[\]{}]/.test(s)) {
    let t = `Anchor must not contain whitespace or control characters: ${JSON.stringify(s)}`;
    throw new Error(t);
} return !0; }
function xt(s) { let e = new Set; return F(s, { Value(t, n) { n.anchor && e.add(n.anchor); } }), e; }
function Kt(s, e) { for (let t = 1;; ++t) {
    let n = `${s}${t}`;
    if (!e.has(n))
        return n;
} }
function gs(s, e) { let t = [], n = new Map, i = null; return { onAnchor: r => { t.push(r), i || (i = xt(s)); let o = Kt(e, i); return i.add(o), o; }, setAnchors: () => { for (let r of t) {
        let o = n.get(r);
        if (typeof o == "object" && o.anchor && (A(o.node) || T(o.node)))
            o.node.anchor = o.anchor;
        else {
            let a = new Error("Failed to resolve repeated object (this should not happen)");
            throw a.source = r, a;
        }
    } }, sourceObjects: n }; }
var G = class extends fe {
    constructor(e) { super(Ze), this.source = e, Object.defineProperty(this, "tag", { set() { throw new Error("Alias nodes cannot have tags"); } }); }
    resolve(e) { let t; return F(e, { Node: (n, i) => { if (i === this)
            return F.BREAK; i.anchor === this.source && (t = i); } }), t; }
    toJSON(e, t) { if (!t)
        return { source: this.source }; let { anchors: n, doc: i, maxAliasCount: r } = t, o = this.resolve(i); if (!o) {
        let l = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
        throw new ReferenceError(l);
    } let a = n.get(o); if (!a || a.res === void 0) {
        let l = "This should not happen: Alias anchor was not resolved?";
        throw new ReferenceError(l);
    } if (r >= 0 && (a.count += 1, a.aliasCount === 0 && (a.aliasCount = st(i, o, n)), a.count * a.aliasCount > r)) {
        let l = "Excessive alias count indicates a resource exhaustion attack";
        throw new ReferenceError(l);
    } return a.res; }
    toString(e, t, n) { let i = `*${this.source}`; if (e) {
        if (tt(this.source), e.options.verifyAliasOrder && !e.anchors.has(this.source)) {
            let r = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
            throw new Error(r);
        }
        if (e.implicitKey)
            return `${i} `;
    } return i; }
};
function st(s, e, t) { if (K(e)) {
    let n = e.resolve(s), i = t && n && t.get(n);
    return i ? i.count * i.aliasCount : 0;
}
else if (T(e)) {
    let n = 0;
    for (let i of e.items) {
        let r = st(s, i, t);
        r > n && (n = r);
    }
    return n;
}
else if (E(e)) {
    let n = st(s, e.key, t), i = st(s, e.value, t);
    return Math.max(n, i);
} return 1; }
function B(s, e, t) { if (Array.isArray(s))
    return s.map((n, i) => B(n, String(i), t)); if (s && typeof s.toJSON == "function") {
    if (!t || !us(s))
        return s.toJSON(e, t);
    let n = { aliasCount: 0, count: 1, res: void 0 };
    t.anchors.set(s, n), t.onCreate = r => { n.res = r, delete t.onCreate; };
    let i = s.toJSON(e, t);
    return t.onCreate && t.onCreate(i), i;
} return typeof s == "bigint" && !t?.keep ? Number(s) : s; }
var nt = s => !s || typeof s != "function" && typeof s != "object", S = class extends fe {
    constructor(e) { super(V), this.value = e; }
    toJSON(e, t) { return t?.keep ? this.value : B(this.value, e, t); }
    toString() { return String(this.value); }
};
S.BLOCK_FOLDED = "BLOCK_FOLDED";
S.BLOCK_LITERAL = "BLOCK_LITERAL";
S.PLAIN = "PLAIN";
S.QUOTE_DOUBLE = "QUOTE_DOUBLE";
S.QUOTE_SINGLE = "QUOTE_SINGLE";
var fn = "tag:yaml.org,2002:";
function un(s, e, t) { if (e) {
    let n = t.filter(r => r.tag === e), i = n.find(r => !r.format) ?? n[0];
    if (!i)
        throw new Error(`Tag ${e} not found`);
    return i;
} return t.find(n => n.identify?.(s) && !n.format); }
function oe(s, e, t) { if (re(s) && (s = s.contents), L(s))
    return s; if (E(s)) {
    let f = t.schema[Q].createNode?.(t.schema, null, t);
    return f.items.push(s), f;
} (s instanceof String || s instanceof Number || s instanceof Boolean || typeof BigInt < "u" && s instanceof BigInt) && (s = s.valueOf()); let { aliasDuplicateObjects: n, onAnchor: i, onTagObj: r, schema: o, sourceObjects: a } = t, l; if (n && s && typeof s == "object") {
    if (l = a.get(s), l)
        return l.anchor || (l.anchor = i(s)), new G(l.anchor);
    l = { anchor: null, node: null }, a.set(s, l);
} e?.startsWith("!!") && (e = fn + e.slice(2)); let c = un(s, e, o.tags); if (!c) {
    if (s && typeof s.toJSON == "function" && (s = s.toJSON()), !s || typeof s != "object") {
        let f = new S(s);
        return l && (l.node = f), f;
    }
    c = s instanceof Map ? o[Q] : Symbol.iterator in Object(s) ? o[ie] : o[Q];
} r && (r(c), delete t.onTagObj); let u = c?.createNode ? c.createNode(t.schema, s, t) : new S(s); return e && (u.tag = e), l && (l.node = u), u; }
function je(s, e, t) { let n = t; for (let i = e.length - 1; i >= 0; --i) {
    let r = e[i];
    if (typeof r == "number" && Number.isInteger(r) && r >= 0) {
        let o = [];
        o[r] = n, n = o;
    }
    else
        n = new Map([[r, n]]);
} return oe(n, void 0, { aliasDuplicateObjects: !1, keepUndefined: !1, onAnchor: () => { throw new Error("This should not happen, please report a bug."); }, schema: s, sourceObjects: new Map }); }
var Ce = s => s == null || typeof s == "object" && !!s[Symbol.iterator]().next().done, ae = class extends fe {
    constructor(e, t) { super(e), Object.defineProperty(this, "schema", { value: t, configurable: !0, enumerable: !1, writable: !0 }); }
    clone(e) { let t = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this)); return e && (t.schema = e), t.items = t.items.map(n => L(n) || E(n) ? n.clone(e) : n), this.range && (t.range = this.range.slice()), t; }
    addIn(e, t) { if (Ce(e))
        this.add(t);
    else {
        let [n, ...i] = e, r = this.get(n, !0);
        if (T(r))
            r.addIn(i, t);
        else if (r === void 0 && this.schema)
            this.set(n, je(this.schema, i, t));
        else
            throw new Error(`Expected YAML collection at ${n}. Remaining path: ${i}`);
    } }
    deleteIn(e) { let [t, ...n] = e; if (n.length === 0)
        return this.delete(t); let i = this.get(t, !0); if (T(i))
        return i.deleteIn(n); throw new Error(`Expected YAML collection at ${t}. Remaining path: ${n}`); }
    getIn(e, t) { let [n, ...i] = e, r = this.get(n, !0); return i.length === 0 ? !t && A(r) ? r.value : r : T(r) ? r.getIn(i, t) : void 0; }
    hasAllNullValues(e) { return this.items.every(t => { if (!E(t))
        return !1; let n = t.value; return n == null || e && A(n) && n.value == null && !n.commentBefore && !n.comment && !n.tag; }); }
    hasIn(e) { let [t, ...n] = e; if (n.length === 0)
        return this.has(t); let i = this.get(t, !0); return T(i) ? i.hasIn(n) : !1; }
    setIn(e, t) { let [n, ...i] = e; if (i.length === 0)
        this.set(n, t);
    else {
        let r = this.get(n, !0);
        if (T(r))
            r.setIn(i, t);
        else if (r === void 0 && this.schema)
            this.set(n, je(this.schema, i, t));
        else
            throw new Error(`Expected YAML collection at ${n}. Remaining path: ${i}`);
    } }
};
ae.maxFlowStringSingleLineLength = 60;
var ys = s => s.replace(/^(?!$)(?: $)?/gm, "#");
function Y(s, e) { return /^\n+$/.test(s) ? s.substring(1) : e ? s.replace(/^(?! *$)/gm, e) : s; }
var W = (s, e, t) => s.endsWith(`
`) ? Y(t, e) : t.includes(`
`) ? `
` + Y(t, e) : (s.endsWith(" ") ? "" : " ") + t;
var qt = "flow", it = "block", xe = "quoted";
function Ke(s, e, t = "flow", { indentAtStart: n, lineWidth: i = 80, minContentWidth: r = 20, onFold: o, onOverflow: a } = {}) {
    if (!i || i < 0)
        return s;
    let l = Math.max(1 + r, 1 + i - e.length);
    if (s.length <= l)
        return s;
    let c = [], u = {}, f = i - e.length;
    typeof n == "number" && (n > i - Math.max(2, r) ? c.push(0) : f = i - n);
    let h, m, y = !1, p = -1, d = -1, b = -1;
    t === it && (p = bs(s, p), p !== -1 && (f = p + l));
    for (let N; N = s[p += 1];) {
        if (t === xe && N === "\\") {
            switch (d = p, s[p + 1]) {
                case "x":
                    p += 3;
                    break;
                case "u":
                    p += 5;
                    break;
                case "U":
                    p += 9;
                    break;
                default: p += 1;
            }
            b = p;
        }
        if (N === `
`)
            t === it && (p = bs(s, p)), f = p + l, h = void 0;
        else {
            if (N === " " && m && m !== " " && m !== `
` && m !== "	") {
                let k = s[p + 1];
                k && k !== " " && k !== `
` && k !== "	" && (h = p);
            }
            if (p >= f)
                if (h)
                    c.push(h), f = h + l, h = void 0;
                else if (t === xe) {
                    for (; m === " " || m === "	";)
                        m = N, N = s[p += 1], y = !0;
                    let k = p > b + 1 ? p - 2 : d - 1;
                    if (u[k])
                        return s;
                    c.push(k), u[k] = !0, f = k + l, h = void 0;
                }
                else
                    y = !0;
        }
        m = N;
    }
    if (y && a && a(), c.length === 0)
        return s;
    o && o();
    let w = s.slice(0, c[0]);
    for (let N = 0; N < c.length; ++N) {
        let k = c[N], O = c[N + 1] || s.length;
        k === 0 ? w = `
${e}${s.slice(0, O)}` : (t === xe && u[k] && (w += `${s[k]}\\`), w += `
${e}${s.slice(k + 1, O)}`);
    }
    return w;
}
function bs(s, e) {
    let t = s[e + 1];
    for (; t === " " || t === "	";) {
        do
            t = s[e += 1];
        while (t && t !== `
`);
        t = s[e + 1];
    }
    return e;
}
var ot = s => ({ indentAtStart: s.indentAtStart, lineWidth: s.options.lineWidth, minContentWidth: s.options.minContentWidth }), at = s => /^(%|---|\.\.\.)/m.test(s);
function hn(s, e, t) {
    if (!e || e < 0)
        return !1;
    let n = e - t, i = s.length;
    if (i <= n)
        return !1;
    for (let r = 0, o = 0; r < i; ++r)
        if (s[r] === `
`) {
            if (r - o > n)
                return !0;
            if (o = r + 1, i - o <= n)
                return !1;
        }
    return !0;
}
function qe(s, e) {
    let t = JSON.stringify(s);
    if (e.options.doubleQuotedAsJSON)
        return t;
    let { implicitKey: n } = e, i = e.options.doubleQuotedMinMultiLineLength, r = e.indent || (at(s) ? "  " : ""), o = "", a = 0;
    for (let l = 0, c = t[l]; c; c = t[++l])
        if (c === " " && t[l + 1] === "\\" && t[l + 2] === "n" && (o += t.slice(a, l) + "\\ ", l += 1, a = l, c = "\\"), c === "\\")
            switch (t[l + 1]) {
                case "u":
                    {
                        o += t.slice(a, l);
                        let u = t.substr(l + 2, 4);
                        switch (u) {
                            case "0000":
                                o += "\\0";
                                break;
                            case "0007":
                                o += "\\a";
                                break;
                            case "000b":
                                o += "\\v";
                                break;
                            case "001b":
                                o += "\\e";
                                break;
                            case "0085":
                                o += "\\N";
                                break;
                            case "00a0":
                                o += "\\_";
                                break;
                            case "2028":
                                o += "\\L";
                                break;
                            case "2029":
                                o += "\\P";
                                break;
                            default: u.substr(0, 2) === "00" ? o += "\\x" + u.substr(2) : o += t.substr(l, 6);
                        }
                        l += 5, a = l + 1;
                    }
                    break;
                case "n":
                    if (n || t[l + 2] === '"' || t.length < i)
                        l += 1;
                    else {
                        for (o += t.slice(a, l) + `

`; t[l + 2] === "\\" && t[l + 3] === "n" && t[l + 4] !== '"';)
                            o += `
`, l += 2;
                        o += r, t[l + 2] === " " && (o += "\\"), l += 1, a = l + 1;
                    }
                    break;
                default: l += 1;
            }
    return o = a ? o + t.slice(a) : t, n ? o : Ke(o, r, xe, ot(e));
}
function Ft(s, e) {
    if (e.options.singleQuote === !1 || e.implicitKey && s.includes(`
`) || /[ \t]\n|\n[ \t]/.test(s))
        return qe(s, e);
    let t = e.indent || (at(s) ? "  " : ""), n = "'" + s.replace(/'/g, "''").replace(/\n+/g, `$&
${t}`) + "'";
    return e.implicitKey ? n : Ke(n, t, qt, ot(e));
}
function ve(s, e) { let { singleQuote: t } = e.options, n; if (t === !1)
    n = qe;
else {
    let i = s.includes('"'), r = s.includes("'");
    i && !r ? n = Ft : r && !i ? n = qe : n = t ? Ft : qe;
} return n(s, e); }
function rt({ comment: s, type: e, value: t }, n, i, r) {
    let { blockQuote: o, commentString: a, lineWidth: l } = n.options;
    if (!o || /\n[\t ]+$/.test(t) || /^\s*$/.test(t))
        return ve(t, n);
    let c = n.indent || (n.forceBlockIndent || at(t) ? "  " : ""), u = o === "literal" ? !0 : o === "folded" || e === S.BLOCK_FOLDED ? !1 : e === S.BLOCK_LITERAL ? !0 : !hn(t, l, c.length);
    if (!t)
        return u ? `|
` : `>
`;
    let f, h;
    for (h = t.length; h > 0; --h) {
        let g = t[h - 1];
        if (g !== `
` && g !== "	" && g !== " ")
            break;
    }
    let m = t.substring(h), y = m.indexOf(`
`);
    y === -1 ? f = "-" : t === m || y !== m.length - 1 ? (f = "+", r && r()) : f = "", m && (t = t.slice(0, -m.length), m[m.length - 1] === `
` && (m = m.slice(0, -1)), m = m.replace(/\n+(?!\n|$)/g, `$&${c}`));
    let p = !1, d, b = -1;
    for (d = 0; d < t.length; ++d) {
        let g = t[d];
        if (g === " ")
            p = !0;
        else if (g === `
`)
            b = d;
        else
            break;
    }
    let w = t.substring(0, b < d ? b + 1 : d);
    w && (t = t.substring(w.length), w = w.replace(/\n+/g, `$&${c}`));
    let k = (u ? "|" : ">") + (p ? c ? "2" : "1" : "") + f;
    if (s && (k += " " + a(s.replace(/ ?[\r\n]+/g, " ")), i && i()), u)
        return t = t.replace(/\n+/g, `$&${c}`), `${k}
${c}${w}${t}${m}`;
    t = t.replace(/\n+/g, `
$&`).replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${c}`);
    let O = Ke(`${w}${t}${m}`, c, it, ot(n));
    return `${k}
${c}${O}`;
}
function pn(s, e, t, n) {
    let { type: i, value: r } = s, { actualString: o, implicitKey: a, indent: l, indentStep: c, inFlow: u } = e;
    if (a && /[\n[\]{},]/.test(r) || u && /[[\]{},]/.test(r))
        return ve(r, e);
    if (!r || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(r))
        return a || u || !r.includes(`
`) ? ve(r, e) : rt(s, e, t, n);
    if (!a && !u && i !== S.PLAIN && r.includes(`
`))
        return rt(s, e, t, n);
    if (at(r)) {
        if (l === "")
            return e.forceBlockIndent = !0, rt(s, e, t, n);
        if (a && l === c)
            return ve(r, e);
    }
    let f = r.replace(/\n+/g, `$&
${l}`);
    if (o) {
        let h = p => p.default && p.tag !== "tag:yaml.org,2002:str" && p.test?.test(f), { compat: m, tags: y } = e.doc.schema;
        if (y.some(h) || m?.some(h))
            return ve(r, e);
    }
    return a ? f : Ke(f, l, qt, ot(e));
}
function le(s, e, t, n) { let { implicitKey: i, inFlow: r } = e, o = typeof s.value == "string" ? s : Object.assign({}, s, { value: String(s.value) }), { type: a } = s; a !== S.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f\u{D800}-\u{DFFF}]/u.test(o.value) && (a = S.QUOTE_DOUBLE); let l = u => { switch (u) {
    case S.BLOCK_FOLDED:
    case S.BLOCK_LITERAL: return i || r ? ve(o.value, e) : rt(o, e, t, n);
    case S.QUOTE_DOUBLE: return qe(o.value, e);
    case S.QUOTE_SINGLE: return Ft(o.value, e);
    case S.PLAIN: return pn(o, e, t, n);
    default: return null;
} }, c = l(a); if (c === null) {
    let { defaultKeyType: u, defaultStringType: f } = e.options, h = i && u || f;
    if (c = l(h), c === null)
        throw new Error(`Unsupported default string type ${h}`);
} return c; }
function lt(s, e) { let t = Object.assign({ blockQuote: !0, commentString: ys, defaultKeyType: null, defaultStringType: "PLAIN", directives: null, doubleQuotedAsJSON: !1, doubleQuotedMinMultiLineLength: 40, falseStr: "false", flowCollectionPadding: !0, indentSeq: !0, lineWidth: 80, minContentWidth: 20, nullStr: "null", simpleKeys: !1, singleQuote: null, trueStr: "true", verifyAliasOrder: !0 }, s.schema.toStringOptions, e), n; switch (t.collectionStyle) {
    case "block":
        n = !1;
        break;
    case "flow":
        n = !0;
        break;
    default: n = null;
} return { anchors: new Set, doc: s, flowCollectionPadding: t.flowCollectionPadding ? " " : "", indent: "", indentStep: typeof t.indent == "number" ? " ".repeat(t.indent) : "  ", inFlow: n, options: t }; }
function mn(s, e) { if (e.tag) {
    let i = s.filter(r => r.tag === e.tag);
    if (i.length > 0)
        return i.find(r => r.format === e.format) ?? i[0];
} let t, n; if (A(e)) {
    n = e.value;
    let i = s.filter(r => r.identify?.(n));
    t = i.find(r => r.format === e.format) ?? i.find(r => !r.format);
}
else
    n = e, t = s.find(i => i.nodeClass && n instanceof i.nodeClass); if (!t) {
    let i = n?.constructor?.name ?? typeof n;
    throw new Error(`Tag not resolved for ${i} value`);
} return t; }
function dn(s, e, { anchors: t, doc: n }) { if (!n.directives)
    return ""; let i = [], r = (A(s) || T(s)) && s.anchor; r && tt(r) && (t.add(r), i.push(`&${r}`)); let o = s.tag ? s.tag : e.default ? null : e.tag; return o && i.push(n.directives.tagString(o)), i.join(" "); }
function H(s, e, t, n) {
    if (E(s))
        return s.toString(e, t, n);
    if (K(s)) {
        if (e.doc.directives)
            return s.toString(e);
        if (e.resolvedAliases?.has(s))
            throw new TypeError("Cannot stringify circular structure without alias nodes");
        e.resolvedAliases ? e.resolvedAliases.add(s) : e.resolvedAliases = new Set([s]), s = s.resolve(e.doc);
    }
    let i, r = L(s) ? s : e.doc.createNode(s, { onTagObj: l => i = l });
    i || (i = mn(e.doc.schema.tags, r));
    let o = dn(r, i, e);
    o.length > 0 && (e.indentAtStart = (e.indentAtStart ?? 0) + o.length + 1);
    let a = typeof i.stringify == "function" ? i.stringify(r, e, t, n) : A(r) ? le(r, e, t, n) : r.toString(e, t, n);
    return o ? A(r) || a[0] === "{" || a[0] === "[" ? `${o} ${a}` : `${o}
${e.indent}${a}` : a;
}
function ws({ key: s, value: e }, t, n, i) {
    let { allNullValues: r, doc: o, indent: a, indentStep: l, options: { commentString: c, indentSeq: u, simpleKeys: f } } = t, h = L(s) && s.comment || null;
    if (f) {
        if (h)
            throw new Error("With simple keys, key nodes cannot have comments");
        if (T(s)) {
            let C = "With simple keys, collection cannot be used as a key value";
            throw new Error(C);
        }
    }
    let m = !f && (!s || h && e == null && !t.inFlow || T(s) || (A(s) ? s.type === S.BLOCK_FOLDED || s.type === S.BLOCK_LITERAL : typeof s == "object"));
    t = Object.assign({}, t, { allNullValues: !1, implicitKey: !m && (f || !r), indent: a + l });
    let y = !1, p = !1, d = H(s, t, () => y = !0, () => p = !0);
    if (!m && !t.inFlow && d.length > 1024) {
        if (f)
            throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
        m = !0;
    }
    if (t.inFlow) {
        if (r || e == null)
            return y && n && n(), d === "" ? "?" : m ? `? ${d}` : d;
    }
    else if (r && !f || e == null && m)
        return d = `? ${d}`, h && !y ? d += W(d, t.indent, c(h)) : p && i && i(), d;
    y && (h = null), m ? (h && (d += W(d, t.indent, c(h))), d = `? ${d}
${a}:`) : (d = `${d}:`, h && (d += W(d, t.indent, c(h))));
    let b, w, N;
    L(e) ? (b = !!e.spaceBefore, w = e.commentBefore, N = e.comment) : (b = !1, w = null, N = null, e && typeof e == "object" && (e = o.createNode(e))), t.implicitKey = !1, !m && !h && A(e) && (t.indentAtStart = d.length + 1), p = !1, !u && l.length >= 2 && !t.inFlow && !m && q(e) && !e.flow && !e.tag && !e.anchor && (t.indent = t.indent.substring(2));
    let k = !1, O = H(e, t, () => k = !0, () => p = !0), g = " ";
    if (h || b || w) {
        if (g = b ? `
` : "", w) {
            let C = c(w);
            g += `
${Y(C, t.indent)}`;
        }
        O === "" && !t.inFlow ? g === `
` && (g = `

`) : g += `
${t.indent}`;
    }
    else if (!m && T(e)) {
        let C = O[0], ne = O.indexOf(`
`), Ee = ne !== -1, U = t.inFlow ?? e.flow ?? e.items.length === 0;
        if (Ee || !U) {
            let fs = !1;
            if (Ee && (C === "&" || C === "!")) {
                let we = O.indexOf(" ");
                C === "&" && we !== -1 && we < ne && O[we + 1] === "!" && (we = O.indexOf(" ", we + 1)), (we === -1 || ne < we) && (fs = !0);
            }
            fs || (g = `
${t.indent}`);
        }
    }
    else
        (O === "" || O[0] === `
`) && (g = "");
    return d += g + O, t.inFlow ? k && n && n() : N && !k ? d += W(d, t.indent, c(N)) : p && i && i(), d;
}
function ct(s, e) { (s === "debug" || s === "warn") && (typeof node_process_js_1.default < "u" && node_process_js_1.default.emitWarning ? node_process_js_1.default.emitWarning(e) : console.warn(e)); }
var Ss = "<<";
function ft(s, e, { key: t, value: n }) { if (s?.doc.schema.merge && gn(t))
    if (n = K(n) ? n.resolve(s.doc) : n, q(n))
        for (let i of n.items)
            Rt(s, e, i);
    else if (Array.isArray(n))
        for (let i of n)
            Rt(s, e, i);
    else
        Rt(s, e, n);
else {
    let i = B(t, "", s);
    if (e instanceof Map)
        e.set(i, B(n, i, s));
    else if (e instanceof Set)
        e.add(i);
    else {
        let r = yn(t, i, s), o = B(n, r, s);
        r in e ? Object.defineProperty(e, r, { value: o, writable: !0, enumerable: !0, configurable: !0 }) : e[r] = o;
    }
} return e; }
var gn = s => s === Ss || A(s) && s.value === Ss && (!s.type || s.type === S.PLAIN);
function Rt(s, e, t) { let n = s && K(t) ? t.resolve(s.doc) : t; if (!M(n))
    throw new Error("Merge sources must be maps or map aliases"); let i = n.toJSON(null, s, Map); for (let [r, o] of i)
    e instanceof Map ? e.has(r) || e.set(r, o) : e instanceof Set ? e.add(r) : Object.prototype.hasOwnProperty.call(e, r) || Object.defineProperty(e, r, { value: o, writable: !0, enumerable: !0, configurable: !0 }); return e; }
function yn(s, e, t) { if (e === null)
    return ""; if (typeof e != "object")
    return String(e); if (L(s) && t && t.doc) {
    let n = lt(t.doc, {});
    n.anchors = new Set;
    for (let r of t.anchors.keys())
        n.anchors.add(r.anchor);
    n.inFlow = !0, n.inStringifyKey = !0;
    let i = s.toString(n);
    if (!t.mapKeyWarned) {
        let r = JSON.stringify(i);
        r.length > 40 && (r = r.substring(0, 36) + '..."'), ct(t.doc.options.logLevel, `Keys with collection values will be stringified due to JS Object restrictions: ${r}. Set mapAsMap: true to use object keys.`), t.mapKeyWarned = !0;
    }
    return i;
} return JSON.stringify(e); }
function $e(s, e, t) { let n = oe(s, void 0, t), i = oe(e, void 0, t); return new I(n, i); }
var I = class {
    constructor(e, t = null) { Object.defineProperty(this, D, { value: jt }), this.key = e, this.value = t; }
    clone(e) { let { key: t, value: n } = this; return L(t) && (t = t.clone(e)), L(n) && (n = n.clone(e)), new I(t, n); }
    toJSON(e, t) { let n = t?.mapAsMap ? new Map : {}; return ft(t, n, this); }
    toString(e, t, n) { return e?.doc ? ws(this, e, t, n) : JSON.stringify(this); }
};
function ht(s, e, t) { return (e.inFlow ?? s.flow ? wn : bn)(s, e, t); }
function bn({ comment: s, items: e }, t, { blockItemPrefix: n, flowChars: i, itemIndent: r, onChompKeep: o, onComment: a }) {
    let { indent: l, options: { commentString: c } } = t, u = Object.assign({}, t, { indent: r, type: null }), f = !1, h = [];
    for (let y = 0; y < e.length; ++y) {
        let p = e[y], d = null;
        if (L(p))
            !f && p.spaceBefore && h.push(""), ut(t, h, p.commentBefore, f), p.comment && (d = p.comment);
        else if (E(p)) {
            let w = L(p.key) ? p.key : null;
            w && (!f && w.spaceBefore && h.push(""), ut(t, h, w.commentBefore, f));
        }
        f = !1;
        let b = H(p, u, () => d = null, () => f = !0);
        d && (b += W(b, r, c(d))), f && d && (f = !1), h.push(n + b);
    }
    let m;
    if (h.length === 0)
        m = i.start + i.end;
    else {
        m = h[0];
        for (let y = 1; y < h.length; ++y) {
            let p = h[y];
            m += p ? `
${l}${p}` : `
`;
        }
    }
    return s ? (m += `
` + Y(c(s), l), a && a()) : f && o && o(), m;
}
function wn({ comment: s, items: e }, t, { flowChars: n, itemIndent: i, onComment: r }) {
    let { indent: o, indentStep: a, flowCollectionPadding: l, options: { commentString: c } } = t;
    i += a;
    let u = Object.assign({}, t, { indent: i, inFlow: !0, type: null }), f = !1, h = 0, m = [];
    for (let b = 0; b < e.length; ++b) {
        let w = e[b], N = null;
        if (L(w))
            w.spaceBefore && m.push(""), ut(t, m, w.commentBefore, !1), w.comment && (N = w.comment);
        else if (E(w)) {
            let O = L(w.key) ? w.key : null;
            O && (O.spaceBefore && m.push(""), ut(t, m, O.commentBefore, !1), O.comment && (f = !0));
            let g = L(w.value) ? w.value : null;
            g ? (g.comment && (N = g.comment), g.commentBefore && (f = !0)) : w.value == null && O && O.comment && (N = O.comment);
        }
        N && (f = !0);
        let k = H(w, u, () => N = null);
        b < e.length - 1 && (k += ","), N && (k += W(k, i, c(N))), !f && (m.length > h || k.includes(`
`)) && (f = !0), m.push(k), h = m.length;
    }
    let y, { start: p, end: d } = n;
    if (m.length === 0)
        y = p + d;
    else if (f || (f = m.reduce((w, N) => w + N.length + 2, 2) > ae.maxFlowStringSingleLineLength), f) {
        y = p;
        for (let b of m)
            y += b ? `
${a}${o}${b}` : `
`;
        y += `
${o}${d}`;
    }
    else
        y = `${p}${l}${m.join(" ")}${l}${d}`;
    return s && (y += W(y, c(s), o), r && r()), y;
}
function ut({ indent: s, options: { commentString: e } }, t, n, i) { if (n && i && (n = n.replace(/^\n+/, "")), n) {
    let r = Y(e(n), s);
    t.push(r.trimStart());
} }
function ue(s, e) { let t = A(e) ? e.value : e; for (let n of s)
    if (E(n) && (n.key === e || n.key === t || A(n.key) && n.key.value === t))
        return n; }
var v = class extends ae {
    static get tagName() { return "tag:yaml.org,2002:map"; }
    constructor(e) { super(Q, e), this.items = []; }
    add(e, t) { let n; E(e) ? n = e : !e || typeof e != "object" || !("key" in e) ? n = new I(e, e?.value) : n = new I(e.key, e.value); let i = ue(this.items, n.key), r = this.schema?.sortMapEntries; if (i) {
        if (!t)
            throw new Error(`Key ${n.key} already set`);
        A(i.value) && nt(n.value) ? i.value.value = n.value : i.value = n.value;
    }
    else if (r) {
        let o = this.items.findIndex(a => r(n, a) < 0);
        o === -1 ? this.items.push(n) : this.items.splice(o, 0, n);
    }
    else
        this.items.push(n); }
    delete(e) { let t = ue(this.items, e); return t ? this.items.splice(this.items.indexOf(t), 1).length > 0 : !1; }
    get(e, t) { let i = ue(this.items, e)?.value; return (!t && A(i) ? i.value : i) ?? void 0; }
    has(e) { return !!ue(this.items, e); }
    set(e, t) { this.add(new I(e, t), !0); }
    toJSON(e, t, n) { let i = n ? new n : t?.mapAsMap ? new Map : {}; t?.onCreate && t.onCreate(i); for (let r of this.items)
        ft(t, i, r); return i; }
    toString(e, t, n) { if (!e)
        return JSON.stringify(this); for (let i of this.items)
        if (!E(i))
            throw new Error(`Map items must all be pairs; found ${JSON.stringify(i)} instead`); return !e.allNullValues && this.hasAllNullValues(!1) && (e = Object.assign({}, e, { allNullValues: !0 })), ht(this, e, { blockItemPrefix: "", flowChars: { start: "{", end: "}" }, itemIndent: e.indent || "", onChompKeep: n, onComment: t }); }
};
function Sn(s, e, t) { let { keepUndefined: n, replacer: i } = t, r = new v(s), o = (a, l) => { if (typeof i == "function")
    l = i.call(e, a, l);
else if (Array.isArray(i) && !i.includes(a))
    return; (l !== void 0 || n) && r.items.push($e(a, l, t)); }; if (e instanceof Map)
    for (let [a, l] of e)
        o(a, l);
else if (e && typeof e == "object")
    for (let a of Object.keys(e))
        o(a, e[a]); return typeof s.sortMapEntries == "function" && r.items.sort(s.sortMapEntries), r; }
var X = { collection: "map", createNode: Sn, default: !0, nodeClass: v, tag: "tag:yaml.org,2002:map", resolve(s, e) { return M(s) || e("Expected a mapping for this tag"), s; } };
var _ = class extends ae {
    static get tagName() { return "tag:yaml.org,2002:seq"; }
    constructor(e) { super(ie, e), this.items = []; }
    add(e) { this.items.push(e); }
    delete(e) { let t = pt(e); return typeof t != "number" ? !1 : this.items.splice(t, 1).length > 0; }
    get(e, t) { let n = pt(e); if (typeof n != "number")
        return; let i = this.items[n]; return !t && A(i) ? i.value : i; }
    has(e) { let t = pt(e); return typeof t == "number" && t < this.items.length; }
    set(e, t) { let n = pt(e); if (typeof n != "number")
        throw new Error(`Expected a valid index, not ${e}.`); let i = this.items[n]; A(i) && nt(t) ? i.value = t : this.items[n] = t; }
    toJSON(e, t) { let n = []; t?.onCreate && t.onCreate(n); let i = 0; for (let r of this.items)
        n.push(B(r, String(i++), t)); return n; }
    toString(e, t, n) { return e ? ht(this, e, { blockItemPrefix: "- ", flowChars: { start: "[", end: "]" }, itemIndent: (e.indent || "") + "  ", onChompKeep: n, onComment: t }) : JSON.stringify(this); }
};
function pt(s) { let e = A(s) ? s.value : s; return e && typeof e == "string" && (e = Number(e)), typeof e == "number" && Number.isInteger(e) && e >= 0 ? e : null; }
function kn(s, e, t) { let { replacer: n } = t, i = new _(s); if (e && Symbol.iterator in Object(e)) {
    let r = 0;
    for (let o of e) {
        if (typeof n == "function") {
            let a = e instanceof Set ? o : String(r++);
            o = n.call(e, a, o);
        }
        i.items.push(oe(o, void 0, t));
    }
} return i; }
var z = { collection: "seq", createNode: kn, default: !0, nodeClass: _, tag: "tag:yaml.org,2002:seq", resolve(s, e) { return q(s) || e("Expected a sequence for this tag"), s; } };
var he = { identify: s => typeof s == "string", default: !0, tag: "tag:yaml.org,2002:str", resolve: s => s, stringify(s, e, t, n) { return e = Object.assign({ actualString: !0 }, e), le(s, e, t, n); } };
var Se = { identify: s => s == null, createNode: () => new S(null), default: !0, tag: "tag:yaml.org,2002:null", test: /^(?:~|[Nn]ull|NULL)?$/, resolve: () => new S(null), stringify: ({ source: s }, e) => typeof s == "string" && Se.test.test(s) ? s : e.options.nullStr };
var Fe = { identify: s => typeof s == "boolean", default: !0, tag: "tag:yaml.org,2002:bool", test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/, resolve: s => new S(s[0] === "t" || s[0] === "T"), stringify({ source: s, value: e }, t) { if (s && Fe.test.test(s)) {
        let n = s[0] === "t" || s[0] === "T";
        if (e === n)
            return s;
    } return e ? t.options.trueStr : t.options.falseStr; } };
function P({ format: s, minFractionDigits: e, tag: t, value: n }) { if (typeof n == "bigint")
    return String(n); let i = typeof n == "number" ? n : Number(n); if (!isFinite(i))
    return isNaN(i) ? ".nan" : i < 0 ? "-.inf" : ".inf"; let r = JSON.stringify(n); if (!s && e && (!t || t === "tag:yaml.org,2002:float") && /^\d/.test(r)) {
    let o = r.indexOf(".");
    o < 0 && (o = r.length, r += ".");
    let a = e - (r.length - o - 1);
    for (; a-- > 0;)
        r += "0";
} return r; }
var mt = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", test: /^(?:[-+]?\.(?:inf|Inf|INF|nan|NaN|NAN))$/, resolve: s => s.slice(-3).toLowerCase() === "nan" ? NaN : s[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY, stringify: P }, dt = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", format: "EXP", test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/, resolve: s => parseFloat(s), stringify(s) { let e = Number(s.value); return isFinite(e) ? e.toExponential() : P(s); } }, gt = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", test: /^[-+]?(?:\.[0-9]+|[0-9]+\.[0-9]*)$/, resolve(s) { let e = new S(parseFloat(s)), t = s.indexOf("."); return t !== -1 && s[s.length - 1] === "0" && (e.minFractionDigits = s.length - t - 1), e; }, stringify: P };
var yt = s => typeof s == "bigint" || Number.isInteger(s), Ut = (s, e, t, { intAsBigInt: n }) => n ? BigInt(s) : parseInt(s.substring(e), t);
function ks(s, e, t) { let { value: n } = s; return yt(n) && n >= 0 ? t + n.toString(e) : P(s); }
var bt = { identify: s => yt(s) && s >= 0, default: !0, tag: "tag:yaml.org,2002:int", format: "OCT", test: /^0o[0-7]+$/, resolve: (s, e, t) => Ut(s, 2, 8, t), stringify: s => ks(s, 8, "0o") }, wt = { identify: yt, default: !0, tag: "tag:yaml.org,2002:int", test: /^[-+]?[0-9]+$/, resolve: (s, e, t) => Ut(s, 0, 10, t), stringify: P }, St = { identify: s => yt(s) && s >= 0, default: !0, tag: "tag:yaml.org,2002:int", format: "HEX", test: /^0x[0-9a-fA-F]+$/, resolve: (s, e, t) => Ut(s, 2, 16, t), stringify: s => ks(s, 16, "0x") };
var Ns = [X, z, he, Se, Fe, bt, wt, St, mt, dt, gt];
function As(s) { return typeof s == "bigint" || Number.isInteger(s); }
var kt = ({ value: s }) => JSON.stringify(s), Nn = [{ identify: s => typeof s == "string", default: !0, tag: "tag:yaml.org,2002:str", resolve: s => s, stringify: kt }, { identify: s => s == null, createNode: () => new S(null), default: !0, tag: "tag:yaml.org,2002:null", test: /^null$/, resolve: () => null, stringify: kt }, { identify: s => typeof s == "boolean", default: !0, tag: "tag:yaml.org,2002:bool", test: /^true|false$/, resolve: s => s === "true", stringify: kt }, { identify: As, default: !0, tag: "tag:yaml.org,2002:int", test: /^-?(?:0|[1-9][0-9]*)$/, resolve: (s, e, { intAsBigInt: t }) => t ? BigInt(s) : parseInt(s, 10), stringify: ({ value: s }) => As(s) ? s.toString() : JSON.stringify(s) }, { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/, resolve: s => parseFloat(s), stringify: kt }], An = { default: !0, tag: "", test: /^/, resolve(s, e) { return e(`Unresolved plain scalar ${JSON.stringify(s)}`), s; } }, Os = [X, z].concat(Nn, An);
var Re = { identify: s => s instanceof Uint8Array, default: !1, tag: "tag:yaml.org,2002:binary", resolve(s, e) { if (typeof node_buffer_js_1.Buffer == "function")
        return node_buffer_js_1.Buffer.from(s, "base64"); if (typeof atob == "function") {
        let t = atob(s.replace(/[\n\r]/g, "")), n = new Uint8Array(t.length);
        for (let i = 0; i < t.length; ++i)
            n[i] = t.charCodeAt(i);
        return n;
    }
    else
        return e("This environment does not support reading binary tags; either Buffer or atob is required"), s; }, stringify({ comment: s, type: e, value: t }, n, i, r) {
        let o = t, a;
        if (typeof node_buffer_js_1.Buffer == "function")
            a = o instanceof node_buffer_js_1.Buffer ? o.toString("base64") : node_buffer_js_1.Buffer.from(o.buffer).toString("base64");
        else if (typeof btoa == "function") {
            let l = "";
            for (let c = 0; c < o.length; ++c)
                l += String.fromCharCode(o[c]);
            a = btoa(l);
        }
        else
            throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
        if (e || (e = S.BLOCK_LITERAL), e !== S.QUOTE_DOUBLE) {
            let l = Math.max(n.options.lineWidth - n.indent.length, n.options.minContentWidth), c = Math.ceil(a.length / l), u = new Array(c);
            for (let f = 0, h = 0; f < c; ++f, h += l)
                u[f] = a.substr(h, l);
            a = u.join(e === S.BLOCK_LITERAL ? `
` : " ");
        }
        return le({ comment: s, type: e, value: a }, n, i, r);
    } };
function Vt(s, e) {
    if (q(s))
        for (let t = 0; t < s.items.length; ++t) {
            let n = s.items[t];
            if (!E(n)) {
                if (M(n)) {
                    n.items.length > 1 && e("Each pair must have its own sequence indicator");
                    let i = n.items[0] || new I(new S(null));
                    if (n.commentBefore && (i.key.commentBefore = i.key.commentBefore ? `${n.commentBefore}
${i.key.commentBefore}` : n.commentBefore), n.comment) {
                        let r = i.value ?? i.key;
                        r.comment = r.comment ? `${n.comment}
${r.comment}` : n.comment;
                    }
                    n = i;
                }
                s.items[t] = E(n) ? n : new I(n);
            }
        }
    else
        e("Expected a sequence for this tag");
    return s;
}
function Yt(s, e, t) { let { replacer: n } = t, i = new _(s); i.tag = "tag:yaml.org,2002:pairs"; let r = 0; if (e && Symbol.iterator in Object(e))
    for (let o of e) {
        typeof n == "function" && (o = n.call(e, String(r++), o));
        let a, l;
        if (Array.isArray(o))
            if (o.length === 2)
                a = o[0], l = o[1];
            else
                throw new TypeError(`Expected [key, value] tuple: ${o}`);
        else if (o && o instanceof Object) {
            let c = Object.keys(o);
            if (c.length === 1)
                a = c[0], l = o[a];
            else
                throw new TypeError(`Expected { key: value } tuple: ${o}`);
        }
        else
            a = o;
        i.items.push($e(a, l, t));
    } return i; }
var Ue = { collection: "seq", default: !1, tag: "tag:yaml.org,2002:pairs", resolve: Vt, createNode: Yt };
var pe = class extends _ {
    constructor() { super(), this.add = v.prototype.add.bind(this), this.delete = v.prototype.delete.bind(this), this.get = v.prototype.get.bind(this), this.has = v.prototype.has.bind(this), this.set = v.prototype.set.bind(this), this.tag = pe.tag; }
    toJSON(e, t) { if (!t)
        return super.toJSON(e); let n = new Map; t?.onCreate && t.onCreate(n); for (let i of this.items) {
        let r, o;
        if (E(i) ? (r = B(i.key, "", t), o = B(i.value, r, t)) : r = B(i, "", t), n.has(r))
            throw new Error("Ordered maps must not include duplicate keys");
        n.set(r, o);
    } return n; }
};
pe.tag = "tag:yaml.org,2002:omap";
var Ve = { collection: "seq", identify: s => s instanceof Map, nodeClass: pe, default: !1, tag: "tag:yaml.org,2002:omap", resolve(s, e) { let t = Vt(s, e), n = []; for (let { key: i } of t.items)
        A(i) && (n.includes(i.value) ? e(`Ordered maps must not include duplicate keys: ${i.value}`) : n.push(i.value)); return Object.assign(new pe, t); }, createNode(s, e, t) { let n = Yt(s, e, t), i = new pe; return i.items = n.items, i; } };
function Es({ value: s, source: e }, t) { return e && (s ? Jt : Qt).test.test(e) ? e : s ? t.options.trueStr : t.options.falseStr; }
var Jt = { identify: s => s === !0, default: !0, tag: "tag:yaml.org,2002:bool", test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/, resolve: () => new S(!0), stringify: Es }, Qt = { identify: s => s === !1, default: !0, tag: "tag:yaml.org,2002:bool", test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i, resolve: () => new S(!1), stringify: Es };
var Ls = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", test: /^[-+]?\.(?:inf|Inf|INF|nan|NaN|NAN)$/, resolve: s => s.slice(-3).toLowerCase() === "nan" ? NaN : s[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY, stringify: P }, Ts = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", format: "EXP", test: /^[-+]?(?:[0-9][0-9_]*)?(?:\.[0-9_]*)?[eE][-+]?[0-9]+$/, resolve: s => parseFloat(s.replace(/_/g, "")), stringify(s) { let e = Number(s.value); return isFinite(e) ? e.toExponential() : P(s); } }, Is = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", test: /^[-+]?(?:[0-9][0-9_]*)?\.[0-9_]*$/, resolve(s) { let e = new S(parseFloat(s.replace(/_/g, ""))), t = s.indexOf("."); if (t !== -1) {
        let n = s.substring(t + 1).replace(/_/g, "");
        n[n.length - 1] === "0" && (e.minFractionDigits = n.length);
    } return e; }, stringify: P };
var Ye = s => typeof s == "bigint" || Number.isInteger(s);
function Nt(s, e, t, { intAsBigInt: n }) { let i = s[0]; if ((i === "-" || i === "+") && (e += 1), s = s.substring(e).replace(/_/g, ""), n) {
    switch (t) {
        case 2:
            s = `0b${s}`;
            break;
        case 8:
            s = `0o${s}`;
            break;
        case 16:
            s = `0x${s}`;
            break;
    }
    let o = BigInt(s);
    return i === "-" ? BigInt(-1) * o : o;
} let r = parseInt(s, t); return i === "-" ? -1 * r : r; }
function Gt(s, e, t) { let { value: n } = s; if (Ye(n)) {
    let i = n.toString(e);
    return n < 0 ? "-" + t + i.substr(1) : t + i;
} return P(s); }
var Cs = { identify: Ye, default: !0, tag: "tag:yaml.org,2002:int", format: "BIN", test: /^[-+]?0b[0-1_]+$/, resolve: (s, e, t) => Nt(s, 2, 2, t), stringify: s => Gt(s, 2, "0b") }, vs = { identify: Ye, default: !0, tag: "tag:yaml.org,2002:int", format: "OCT", test: /^[-+]?0[0-7_]+$/, resolve: (s, e, t) => Nt(s, 1, 8, t), stringify: s => Gt(s, 8, "0") }, $s = { identify: Ye, default: !0, tag: "tag:yaml.org,2002:int", test: /^[-+]?[0-9][0-9_]*$/, resolve: (s, e, t) => Nt(s, 0, 10, t), stringify: P }, _s = { identify: Ye, default: !0, tag: "tag:yaml.org,2002:int", format: "HEX", test: /^[-+]?0x[0-9a-fA-F_]+$/, resolve: (s, e, t) => Nt(s, 2, 16, t), stringify: s => Gt(s, 16, "0x") };
var me = class extends v {
    constructor(e) { super(e), this.tag = me.tag; }
    add(e) { let t; E(e) ? t = e : e && typeof e == "object" && "key" in e && "value" in e && e.value === null ? t = new I(e.key, null) : t = new I(e, null), ue(this.items, t.key) || this.items.push(t); }
    get(e, t) { let n = ue(this.items, e); return !t && E(n) ? A(n.key) ? n.key.value : n.key : n; }
    set(e, t) { if (typeof t != "boolean")
        throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof t}`); let n = ue(this.items, e); n && !t ? this.items.splice(this.items.indexOf(n), 1) : !n && t && this.items.push(new I(e)); }
    toJSON(e, t) { return super.toJSON(e, t, Set); }
    toString(e, t, n) { if (!e)
        return JSON.stringify(this); if (this.hasAllNullValues(!0))
        return super.toString(Object.assign({}, e, { allNullValues: !0 }), t, n); throw new Error("Set items must all have null values"); }
};
me.tag = "tag:yaml.org,2002:set";
var Je = { collection: "map", identify: s => s instanceof Set, nodeClass: me, default: !1, tag: "tag:yaml.org,2002:set", resolve(s, e) { if (M(s)) {
        if (s.hasAllNullValues(!0))
            return Object.assign(new me, s);
        e("Set items must all have null values");
    }
    else
        e("Expected a mapping for this tag"); return s; }, createNode(s, e, t) { let { replacer: n } = t, i = new me(s); if (e && Symbol.iterator in Object(e))
        for (let r of e)
            typeof n == "function" && (r = n.call(e, r, r)), i.items.push($e(r, null, t)); return i; } };
function Wt(s, e) { let t = s[0], n = t === "-" || t === "+" ? s.substring(1) : s, i = o => e ? BigInt(o) : Number(o), r = n.replace(/_/g, "").split(":").reduce((o, a) => o * i(60) + i(a), i(0)); return t === "-" ? i(-1) * r : r; }
function Ps(s) { let { value: e } = s, t = o => o; if (typeof e == "bigint")
    t = o => BigInt(o);
else if (isNaN(e) || !isFinite(e))
    return P(s); let n = ""; e < 0 && (n = "-", e *= t(-1)); let i = t(60), r = [e % i]; return e < 60 ? r.unshift(0) : (e = (e - r[0]) / i, r.unshift(e % i), e >= 60 && (e = (e - r[0]) / i, r.unshift(e))), n + r.map(o => o < 10 ? "0" + String(o) : String(o)).join(":").replace(/000000\d*$/, ""); }
var At = { identify: s => typeof s == "bigint" || Number.isInteger(s), default: !0, tag: "tag:yaml.org,2002:int", format: "TIME", test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+$/, resolve: (s, e, { intAsBigInt: t }) => Wt(s, t), stringify: Ps }, Ot = { identify: s => typeof s == "number", default: !0, tag: "tag:yaml.org,2002:float", format: "TIME", test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*$/, resolve: s => Wt(s, !1), stringify: Ps }, _e = { identify: s => s instanceof Date, default: !0, tag: "tag:yaml.org,2002:timestamp", test: RegExp("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?$"), resolve(s) { let e = s.match(_e.test); if (!e)
        throw new Error("!!timestamp expects a date, starting with yyyy-mm-dd"); let [, t, n, i, r, o, a] = e.map(Number), l = e[7] ? Number((e[7] + "00").substr(1, 3)) : 0, c = Date.UTC(t, n - 1, i, r || 0, o || 0, a || 0, l), u = e[8]; if (u && u !== "Z") {
        let f = Wt(u, !1);
        Math.abs(f) < 30 && (f *= 60), c -= 6e4 * f;
    } return new Date(c); }, stringify: ({ value: s }) => s.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "") };
var Ht = [X, z, he, Se, Jt, Qt, Cs, vs, $s, _s, Ls, Ts, Is, Re, Ve, Ue, Je, At, Ot, _e];
var Ms = new Map([["core", Ns], ["failsafe", [X, z, he]], ["json", Os], ["yaml11", Ht], ["yaml-1.1", Ht]]), Bs = { binary: Re, bool: Fe, float: gt, floatExp: dt, floatNaN: mt, floatTime: Ot, int: wt, intHex: St, intOct: bt, intTime: At, map: X, null: Se, omap: Ve, pairs: Ue, seq: z, set: Je, timestamp: _e }, Ds = { "tag:yaml.org,2002:binary": Re, "tag:yaml.org,2002:omap": Ve, "tag:yaml.org,2002:pairs": Ue, "tag:yaml.org,2002:set": Je, "tag:yaml.org,2002:timestamp": _e };
function Et(s, e) { let t = Ms.get(e); if (!t)
    if (Array.isArray(s))
        t = [];
    else {
        let n = Array.from(Ms.keys()).filter(i => i !== "yaml11").map(i => JSON.stringify(i)).join(", ");
        throw new Error(`Unknown schema "${e}"; use one of ${n} or define customTags array`);
    } if (Array.isArray(s))
    for (let n of s)
        t = t.concat(n);
else
    typeof s == "function" && (t = s(t.slice())); return t.map(n => { if (typeof n != "string")
    return n; let i = Bs[n]; if (i)
    return i; let r = Object.keys(Bs).map(o => JSON.stringify(o)).join(", "); throw new Error(`Unknown custom tag "${n}"; use one of ${r}`); }); }
var On = (s, e) => s.key < e.key ? -1 : s.key > e.key ? 1 : 0, ce = class {
    constructor({ compat: e, customTags: t, merge: n, resolveKnownTags: i, schema: r, sortMapEntries: o, toStringDefaults: a }) { this.compat = Array.isArray(e) ? Et(e, "compat") : e ? Et(null, e) : null, this.merge = !!n, this.name = typeof r == "string" && r || "core", this.knownTags = i ? Ds : {}, this.tags = Et(t, this.name), this.toStringOptions = a ?? null, Object.defineProperty(this, Q, { value: X }), Object.defineProperty(this, V, { value: he }), Object.defineProperty(this, ie, { value: z }), this.sortMapEntries = typeof o == "function" ? o : o === !0 ? On : null; }
    clone() { let e = Object.create(ce.prototype, Object.getOwnPropertyDescriptors(this)); return e.tags = this.tags.slice(), e; }
};
function js(s, e) {
    let t = [], n = e.directives === !0;
    if (e.directives !== !1 && s.directives) {
        let l = s.directives.toString(s);
        l ? (t.push(l), n = !0) : s.directives.docStart && (n = !0);
    }
    n && t.push("---");
    let i = lt(s, e), { commentString: r } = i.options;
    if (s.commentBefore) {
        t.length !== 1 && t.unshift("");
        let l = r(s.commentBefore);
        t.unshift(Y(l, ""));
    }
    let o = !1, a = null;
    if (s.contents) {
        if (L(s.contents)) {
            if (s.contents.spaceBefore && n && t.push(""), s.contents.commentBefore) {
                let u = r(s.contents.commentBefore);
                t.push(Y(u, ""));
            }
            i.forceBlockIndent = !!s.comment, a = s.contents.comment;
        }
        let l = a ? void 0 : () => o = !0, c = H(s.contents, i, () => a = null, l);
        a && (c += W(c, "", r(a))), (c[0] === "|" || c[0] === ">") && t[t.length - 1] === "---" ? t[t.length - 1] = `--- ${c}` : t.push(c);
    }
    else
        t.push(H(s.contents, i));
    if (s.directives?.docEnd)
        if (s.comment) {
            let l = r(s.comment);
            l.includes(`
`) ? (t.push("..."), t.push(Y(l, ""))) : t.push(`... ${l}`);
        }
        else
            t.push("...");
    else {
        let l = s.comment;
        l && o && (l = l.replace(/^\n+/, "")), l && ((!o || a) && t[t.length - 1] !== "" && t.push(""), t.push(Y(r(l), "")));
    }
    return t.join(`
`) + `
`;
}
function Pe(s, e, t, n) { if (n && typeof n == "object")
    if (Array.isArray(n))
        for (let i = 0, r = n.length; i < r; ++i) {
            let o = n[i], a = Pe(s, n, String(i), o);
            a === void 0 ? delete n[i] : a !== o && (n[i] = a);
        }
    else if (n instanceof Map)
        for (let i of Array.from(n.keys())) {
            let r = n.get(i), o = Pe(s, n, i, r);
            o === void 0 ? n.delete(i) : o !== r && n.set(i, o);
        }
    else if (n instanceof Set)
        for (let i of Array.from(n)) {
            let r = Pe(s, n, i, i);
            r === void 0 ? n.delete(i) : r !== i && (n.delete(i), n.add(r));
        }
    else
        for (let [i, r] of Object.entries(n)) {
            let o = Pe(s, n, i, r);
            o === void 0 ? delete n[i] : o !== r && (n[i] = o);
        } return s.call(e, t, n); }
var R = class {
    constructor(e, t, n) { this.commentBefore = null, this.comment = null, this.errors = [], this.warnings = [], Object.defineProperty(this, D, { value: et }); let i = null; typeof t == "function" || Array.isArray(t) ? i = t : n === void 0 && t && (n = t, t = void 0); let r = Object.assign({ intAsBigInt: !1, keepSourceTokens: !1, logLevel: "warn", prettyErrors: !0, strict: !0, uniqueKeys: !0, version: "1.2" }, n); this.options = r; let { version: o } = r; n?._directives ? (this.directives = n._directives.atDocument(), this.directives.yaml.explicit && (o = this.directives.yaml.version)) : this.directives = new $({ version: o }), this.setSchema(o, n), e === void 0 ? this.contents = null : this.contents = this.createNode(e, i, n); }
    clone() { let e = Object.create(R.prototype, { [D]: { value: et } }); return e.commentBefore = this.commentBefore, e.comment = this.comment, e.errors = this.errors.slice(), e.warnings = this.warnings.slice(), e.options = Object.assign({}, this.options), this.directives && (e.directives = this.directives.clone()), e.schema = this.schema.clone(), e.contents = L(this.contents) ? this.contents.clone(e.schema) : this.contents, this.range && (e.range = this.range.slice()), e; }
    add(e) { Me(this.contents) && this.contents.add(e); }
    addIn(e, t) { Me(this.contents) && this.contents.addIn(e, t); }
    createAlias(e, t) { if (!e.anchor) {
        let n = xt(this);
        e.anchor = !t || n.has(t) ? Kt(t || "a", n) : t;
    } return new G(e.anchor); }
    createNode(e, t, n) { let i; if (typeof t == "function")
        e = t.call({ "": e }, "", e), i = t;
    else if (Array.isArray(t)) {
        let d = w => typeof w == "number" || w instanceof String || w instanceof Number, b = t.filter(d).map(String);
        b.length > 0 && (t = t.concat(b)), i = t;
    }
    else
        n === void 0 && t && (n = t, t = void 0); let { aliasDuplicateObjects: r, anchorPrefix: o, flow: a, keepUndefined: l, onTagObj: c, tag: u } = n ?? {}, { onAnchor: f, setAnchors: h, sourceObjects: m } = gs(this, o || "a"), y = { aliasDuplicateObjects: r ?? !0, keepUndefined: l ?? !1, onAnchor: f, onTagObj: c, replacer: i, schema: this.schema, sourceObjects: m }, p = oe(e, u, y); return a && T(p) && (p.flow = !0), h(), p; }
    createPair(e, t, n = {}) { let i = this.createNode(e, null, n), r = this.createNode(t, null, n); return new I(i, r); }
    delete(e) { return Me(this.contents) ? this.contents.delete(e) : !1; }
    deleteIn(e) { return Ce(e) ? this.contents == null ? !1 : (this.contents = null, !0) : Me(this.contents) ? this.contents.deleteIn(e) : !1; }
    get(e, t) { return T(this.contents) ? this.contents.get(e, t) : void 0; }
    getIn(e, t) { return Ce(e) ? !t && A(this.contents) ? this.contents.value : this.contents : T(this.contents) ? this.contents.getIn(e, t) : void 0; }
    has(e) { return T(this.contents) ? this.contents.has(e) : !1; }
    hasIn(e) { return Ce(e) ? this.contents !== void 0 : T(this.contents) ? this.contents.hasIn(e) : !1; }
    set(e, t) { this.contents == null ? this.contents = je(this.schema, [e], t) : Me(this.contents) && this.contents.set(e, t); }
    setIn(e, t) { Ce(e) ? this.contents = t : this.contents == null ? this.contents = je(this.schema, Array.from(e), t) : Me(this.contents) && this.contents.setIn(e, t); }
    setSchema(e, t = {}) { typeof e == "number" && (e = String(e)); let n; switch (e) {
        case "1.1":
            this.directives ? this.directives.yaml.version = "1.1" : this.directives = new $({ version: "1.1" }), n = { merge: !0, resolveKnownTags: !1, schema: "yaml-1.1" };
            break;
        case "1.2":
        case "next":
            this.directives ? this.directives.yaml.version = e : this.directives = new $({ version: e }), n = { merge: !1, resolveKnownTags: !0, schema: "core" };
            break;
        case null:
            this.directives && delete this.directives, n = null;
            break;
        default: {
            let i = JSON.stringify(e);
            throw new Error(`Expected '1.1', '1.2' or null as first argument, but found: ${i}`);
        }
    } if (t.schema instanceof Object)
        this.schema = t.schema;
    else if (n)
        this.schema = new ce(Object.assign(n, t));
    else
        throw new Error("With a null YAML version, the { schema: Schema } option is required"); }
    toJS({ json: e, jsonArg: t, mapAsMap: n, maxAliasCount: i, onAnchor: r, reviver: o } = {}) { let a = { anchors: new Map, doc: this, keep: !e, mapAsMap: n === !0, mapKeyWarned: !1, maxAliasCount: typeof i == "number" ? i : 100, stringify: H }, l = B(this.contents, t ?? "", a); if (typeof r == "function")
        for (let { count: c, res: u } of a.anchors.values())
            r(u, c); return typeof o == "function" ? Pe(o, { "": l }, "", l) : l; }
    toJSON(e, t) { return this.toJS({ json: !0, jsonArg: e, mapAsMap: !1, onAnchor: t }); }
    toString(e = {}) { if (this.errors.length > 0)
        throw new Error("Document with errors cannot be stringified"); if ("indent" in e && (!Number.isInteger(e.indent) || Number(e.indent) <= 0)) {
        let t = JSON.stringify(e.indent);
        throw new Error(`"indent" option must be a positive integer, not ${t}`);
    } return js(this, e); }
};
function Me(s) { if (T(s))
    return !0; throw new Error("Expected a YAML collection as document contents"); }
var ke = class extends Error {
    constructor(e, t, n, i) { super(), this.name = e, this.code = n, this.message = i, this.pos = t; }
}, x = class extends ke {
    constructor(e, t, n) { super("YAMLParseError", e, t, n); }
}, Ne = class extends ke {
    constructor(e, t, n) { super("YAMLWarning", e, t, n); }
}, Qe = (s, e) => t => {
    if (t.pos[0] === -1)
        return;
    t.linePos = t.pos.map(a => e.linePos(a));
    let { line: n, col: i } = t.linePos[0];
    t.message += ` at line ${n}, column ${i}`;
    let r = i - 1, o = s.substring(e.lineStarts[n - 1], e.lineStarts[n]).replace(/[\n\r]+$/, "");
    if (r >= 60 && o.length > 80) {
        let a = Math.min(r - 39, o.length - 79);
        o = "\u2026" + o.substring(a), r -= a - 1;
    }
    if (o.length > 80 && (o = o.substring(0, 79) + "\u2026"), n > 1 && /^ *$/.test(o.substring(0, r))) {
        let a = s.substring(e.lineStarts[n - 2], e.lineStarts[n - 1]);
        a.length > 80 && (a = a.substring(0, 79) + `\u2026
`), o = a + o;
    }
    if (/[^ ]/.test(o)) {
        let a = 1, l = t.linePos[1];
        l && l.line === n && l.col > i && (a = Math.min(l.col - i, 80 - r));
        let c = " ".repeat(r) + "^".repeat(a);
        t.message += `:

${o}
${c}
`;
    }
};
function te(s, { flow: e, indicator: t, next: n, offset: i, onError: r, startOnNewline: o }) { let a = !1, l = o, c = o, u = "", f = "", h = !1, m = !1, y = !1, p = null, d = null, b = null, w = null, N = null; for (let g of s)
    switch (y && (g.type !== "space" && g.type !== "newline" && g.type !== "comma" && r(g.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space"), y = !1), g.type) {
        case "space":
            !e && l && t !== "doc-start" && g.source[0] === "	" && r(g, "TAB_AS_INDENT", "Tabs are not allowed as indentation"), c = !0;
            break;
        case "comment": {
            c || r(g, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
            let C = g.source.substring(1) || " ";
            u ? u += f + C : u = C, f = "", l = !1;
            break;
        }
        case "newline":
            l ? u ? u += g.source : a = !0 : f += g.source, l = !0, h = !0, (p || d) && (m = !0), c = !0;
            break;
        case "anchor":
            p && r(g, "MULTIPLE_ANCHORS", "A node can have at most one anchor"), g.source.endsWith(":") && r(g.offset + g.source.length - 1, "BAD_ALIAS", "Anchor ending in : is ambiguous", !0), p = g, N === null && (N = g.offset), l = !1, c = !1, y = !0;
            break;
        case "tag": {
            d && r(g, "MULTIPLE_TAGS", "A node can have at most one tag"), d = g, N === null && (N = g.offset), l = !1, c = !1, y = !0;
            break;
        }
        case t:
            (p || d) && r(g, "BAD_PROP_ORDER", `Anchors and tags must be after the ${g.source} indicator`), w && r(g, "UNEXPECTED_TOKEN", `Unexpected ${g.source} in ${e ?? "collection"}`), w = g, l = !1, c = !1;
            break;
        case "comma": if (e) {
            b && r(g, "UNEXPECTED_TOKEN", `Unexpected , in ${e}`), b = g, l = !1, c = !1;
            break;
        }
        default: r(g, "UNEXPECTED_TOKEN", `Unexpected ${g.type} token`), l = !1, c = !1;
    } let k = s[s.length - 1], O = k ? k.offset + k.source.length : i; return y && n && n.type !== "space" && n.type !== "newline" && n.type !== "comma" && (n.type !== "scalar" || n.source !== "") && r(n.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space"), { comma: b, found: w, spaceBefore: a, comment: u, hasNewline: h, hasNewlineAfterProp: m, anchor: p, tag: d, end: O, start: N ?? O }; }
function de(s) {
    if (!s)
        return null;
    switch (s.type) {
        case "alias":
        case "scalar":
        case "double-quoted-scalar":
        case "single-quoted-scalar":
            if (s.source.includes(`
`))
                return !0;
            if (s.end) {
                for (let e of s.end)
                    if (e.type === "newline")
                        return !0;
            }
            return !1;
        case "flow-collection":
            for (let e of s.items) {
                for (let t of e.start)
                    if (t.type === "newline")
                        return !0;
                if (e.sep) {
                    for (let t of e.sep)
                        if (t.type === "newline")
                            return !0;
                }
                if (de(e.key) || de(e.value))
                    return !0;
            }
            return !1;
        default: return !0;
    }
}
function Ge(s, e, t) { if (e?.type === "flow-collection") {
    let n = e.end[0];
    n.indent === s && (n.source === "]" || n.source === "}") && de(e) && t(n, "BAD_INDENT", "Flow end indicator should be more indented than parent", !0);
} }
function Lt(s, e, t) { let { uniqueKeys: n } = s.options; if (n === !1)
    return !1; let i = typeof n == "function" ? n : (r, o) => r === o || A(r) && A(o) && r.value === o.value && !(r.value === "<<" && s.schema.merge); return e.some(r => i(r.key, t)); }
var xs = "All mapping items must start at the same column";
function Ks({ composeNode: s, composeEmptyNode: e }, t, n, i) {
    let r = new v(t.schema);
    t.atRoot && (t.atRoot = !1);
    let o = n.offset, a = null;
    for (let l of n.items) {
        let { start: c, key: u, sep: f, value: h } = l, m = te(c, { indicator: "explicit-key-ind", next: u ?? f?.[0], offset: o, onError: i, startOnNewline: !0 }), y = !m.found;
        if (y) {
            if (u && (u.type === "block-seq" ? i(o, "BLOCK_AS_IMPLICIT_KEY", "A block sequence may not be used as an implicit map key") : "indent" in u && u.indent !== n.indent && i(o, "BAD_INDENT", xs)), !m.anchor && !m.tag && !f) {
                a = m.end, m.comment && (r.comment ? r.comment += `
` + m.comment : r.comment = m.comment);
                continue;
            }
            (m.hasNewlineAfterProp || de(u)) && i(u ?? c[c.length - 1], "MULTILINE_IMPLICIT_KEY", "Implicit keys need to be on a single line");
        }
        else
            m.found?.indent !== n.indent && i(o, "BAD_INDENT", xs);
        let p = m.end, d = u ? s(t, u, m, i) : e(t, p, c, null, m, i);
        t.schema.compat && Ge(n.indent, u, i), Lt(t, r.items, d) && i(p, "DUPLICATE_KEY", "Map keys must be unique");
        let b = te(f ?? [], { indicator: "map-value-ind", next: h, offset: d.range[2], onError: i, startOnNewline: !u || u.type === "block-scalar" });
        if (o = b.end, b.found) {
            y && (h?.type === "block-map" && !b.hasNewline && i(o, "BLOCK_AS_IMPLICIT_KEY", "Nested mappings are not allowed in compact mappings"), t.options.strict && m.start < b.found.offset - 1024 && i(d.range, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit block mapping key"));
            let w = h ? s(t, h, b, i) : e(t, o, f, null, b, i);
            t.schema.compat && Ge(n.indent, h, i), o = w.range[2];
            let N = new I(d, w);
            t.options.keepSourceTokens && (N.srcToken = l), r.items.push(N);
        }
        else {
            y && i(d.range, "MISSING_CHAR", "Implicit map keys need to be followed by map values"), b.comment && (d.comment ? d.comment += `
` + b.comment : d.comment = b.comment);
            let w = new I(d);
            t.options.keepSourceTokens && (w.srcToken = l), r.items.push(w);
        }
    }
    return a && a < o && i(a, "IMPOSSIBLE", "Map comment with trailing content"), r.range = [n.offset, o, a ?? o], r;
}
function qs({ composeNode: s, composeEmptyNode: e }, t, n, i) { let r = new _(t.schema); t.atRoot && (t.atRoot = !1); let o = n.offset, a = null; for (let { start: l, value: c } of n.items) {
    let u = te(l, { indicator: "seq-item-ind", next: c, offset: o, onError: i, startOnNewline: !0 });
    if (!u.found)
        if (u.anchor || u.tag || c)
            c && c.type === "block-seq" ? i(u.end, "BAD_INDENT", "All sequence items must start at the same column") : i(o, "MISSING_CHAR", "Sequence item without - indicator");
        else {
            a = u.end, u.comment && (r.comment = u.comment);
            continue;
        }
    let f = c ? s(t, c, u, i) : e(t, u.end, l, null, u, i);
    t.schema.compat && Ge(n.indent, c, i), o = f.range[2], r.items.push(f);
} return r.range = [n.offset, o, a ?? o], r; }
function se(s, e, t, n) { let i = ""; if (s) {
    let r = !1, o = "";
    for (let a of s) {
        let { source: l, type: c } = a;
        switch (c) {
            case "space":
                r = !0;
                break;
            case "comment": {
                t && !r && n(a, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
                let u = l.substring(1) || " ";
                i ? i += o + u : i = u, o = "";
                break;
            }
            case "newline":
                i && (o += l), r = !0;
                break;
            default: n(a, "UNEXPECTED_TOKEN", `Unexpected ${c} at node end`);
        }
        e += l.length;
    }
} return { comment: i, offset: e }; }
var Xt = "Block collections are not allowed within flow collections", zt = s => s && (s.type === "block-map" || s.type === "block-seq");
function Fs({ composeNode: s, composeEmptyNode: e }, t, n, i) {
    let r = n.start.source === "{", o = r ? "flow map" : "flow sequence", a = r ? new v(t.schema) : new _(t.schema);
    a.flow = !0;
    let l = t.atRoot;
    l && (t.atRoot = !1);
    let c = n.offset + n.start.source.length;
    for (let y = 0; y < n.items.length; ++y) {
        let p = n.items[y], { start: d, key: b, sep: w, value: N } = p, k = te(d, { flow: o, indicator: "explicit-key-ind", next: b ?? w?.[0], offset: c, onError: i, startOnNewline: !1 });
        if (!k.found) {
            if (!k.anchor && !k.tag && !w && !N) {
                y === 0 && k.comma ? i(k.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${o}`) : y < n.items.length - 1 && i(k.start, "UNEXPECTED_TOKEN", `Unexpected empty item in ${o}`), k.comment && (a.comment ? a.comment += `
` + k.comment : a.comment = k.comment), c = k.end;
                continue;
            }
            !r && t.options.strict && de(b) && i(b, "MULTILINE_IMPLICIT_KEY", "Implicit keys of flow sequence pairs need to be on a single line");
        }
        if (y === 0)
            k.comma && i(k.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${o}`);
        else if (k.comma || i(k.start, "MISSING_CHAR", `Missing , between ${o} items`), k.comment) {
            let O = "";
            e: for (let g of d)
                switch (g.type) {
                    case "comma":
                    case "space": break;
                    case "comment":
                        O = g.source.substring(1);
                        break e;
                    default: break e;
                }
            if (O) {
                let g = a.items[a.items.length - 1];
                E(g) && (g = g.value ?? g.key), g.comment ? g.comment += `
` + O : g.comment = O, k.comment = k.comment.substring(O.length + 1);
            }
        }
        if (!r && !w && !k.found) {
            let O = N ? s(t, N, k, i) : e(t, k.end, w, null, k, i);
            a.items.push(O), c = O.range[2], zt(N) && i(O.range, "BLOCK_IN_FLOW", Xt);
        }
        else {
            let O = k.end, g = b ? s(t, b, k, i) : e(t, O, d, null, k, i);
            zt(b) && i(g.range, "BLOCK_IN_FLOW", Xt);
            let C = te(w ?? [], { flow: o, indicator: "map-value-ind", next: N, offset: g.range[2], onError: i, startOnNewline: !1 });
            if (C.found) {
                if (!r && !k.found && t.options.strict) {
                    if (w)
                        for (let U of w) {
                            if (U === C.found)
                                break;
                            if (U.type === "newline") {
                                i(U, "MULTILINE_IMPLICIT_KEY", "Implicit keys of flow sequence pairs need to be on a single line");
                                break;
                            }
                        }
                    k.start < C.found.offset - 1024 && i(C.found, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit flow sequence key");
                }
            }
            else
                N && ("source" in N && N.source && N.source[0] === ":" ? i(N, "MISSING_CHAR", `Missing space after : in ${o}`) : i(C.start, "MISSING_CHAR", `Missing , or : between ${o} items`));
            let ne = N ? s(t, N, C, i) : C.found ? e(t, C.end, w, null, C, i) : null;
            ne ? zt(N) && i(ne.range, "BLOCK_IN_FLOW", Xt) : C.comment && (g.comment ? g.comment += `
` + C.comment : g.comment = C.comment);
            let Ee = new I(g, ne);
            if (t.options.keepSourceTokens && (Ee.srcToken = p), r) {
                let U = a;
                Lt(t, U.items, g) && i(O, "DUPLICATE_KEY", "Map keys must be unique"), U.items.push(Ee);
            }
            else {
                let U = new v(t.schema);
                U.flow = !0, U.items.push(Ee), a.items.push(U);
            }
            c = ne ? ne.range[2] : C.end;
        }
    }
    let u = r ? "}" : "]", [f, ...h] = n.end, m = c;
    if (f && f.source === u)
        m = f.offset + f.source.length;
    else {
        let y = o[0].toUpperCase() + o.substring(1), p = l ? `${y} must end with a ${u}` : `${y} in block collection must be sufficiently indented and end with a ${u}`;
        i(c, l ? "MISSING_CHAR" : "BAD_INDENT", p), f && f.source.length !== 1 && h.unshift(f);
    }
    if (h.length > 0) {
        let y = se(h, m, t.options.strict, i);
        y.comment && (a.comment ? a.comment += `
` + y.comment : a.comment = y.comment), a.range = [n.offset, m, y.offset];
    }
    else
        a.range = [n.offset, m, m];
    return a;
}
function Rs(s, e, t, n, i) { let r; switch (t.type) {
    case "block-map": {
        r = Ks(s, e, t, i);
        break;
    }
    case "block-seq": {
        r = qs(s, e, t, i);
        break;
    }
    case "flow-collection": {
        r = Fs(s, e, t, i);
        break;
    }
} if (!n)
    return r; let o = e.directives.tagName(n.source, h => i(n, "TAG_RESOLVE_FAILED", h)); if (!o)
    return r; let a = r.constructor; if (o === "!" || o === a.tagName)
    return r.tag = a.tagName, r; let l = M(r) ? "map" : "seq", c = e.schema.tags.find(h => h.collection === l && h.tag === o); if (!c) {
    let h = e.schema.knownTags[o];
    if (h && h.collection === l)
        e.schema.tags.push(Object.assign({}, h, { default: !1 })), c = h;
    else
        return i(n, "TAG_RESOLVE_FAILED", `Unresolved tag: ${o}`, !0), r.tag = o, r;
} let u = c.resolve(r, h => i(n, "TAG_RESOLVE_FAILED", h), e.options), f = L(u) ? u : new S(u); return f.range = r.range, f.tag = o, c?.format && (f.format = c.format), f; }
function Tt(s, e, t) {
    let n = s.offset, i = En(s, e, t);
    if (!i)
        return { value: "", type: null, comment: "", range: [n, n, n] };
    let r = i.mode === ">" ? S.BLOCK_FOLDED : S.BLOCK_LITERAL, o = s.source ? Ln(s.source) : [], a = o.length;
    for (let p = o.length - 1; p >= 0; --p) {
        let d = o[p][1];
        if (d === "" || d === "\r")
            a = p;
        else
            break;
    }
    if (a === 0) {
        let p = i.chomp === "+" && o.length > 0 ? `
`.repeat(Math.max(1, o.length - 1)) : "", d = n + i.length;
        return s.source && (d += s.source.length), { value: p, type: r, comment: i.comment, range: [n, d, d] };
    }
    let l = s.indent + i.indent, c = s.offset + i.length, u = 0;
    for (let p = 0; p < a; ++p) {
        let [d, b] = o[p];
        if (b === "" || b === "\r")
            i.indent === 0 && d.length > l && (l = d.length);
        else {
            if (d.length < l) {
                let w = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
                t(c + d.length, "MISSING_CHAR", w);
            }
            i.indent === 0 && (l = d.length), u = p;
            break;
        }
        c += d.length + b.length + 1;
    }
    for (let p = o.length - 1; p >= a; --p)
        o[p][0].length > l && (a = p + 1);
    let f = "", h = "", m = !1;
    for (let p = 0; p < u; ++p)
        f += o[p][0].slice(l) + `
`;
    for (let p = u; p < a; ++p) {
        let [d, b] = o[p];
        c += d.length + b.length + 1;
        let w = b[b.length - 1] === "\r";
        if (w && (b = b.slice(0, -1)), b && d.length < l) {
            let k = `Block scalar lines must not be less indented than their ${i.indent ? "explicit indentation indicator" : "first line"}`;
            t(c - b.length - (w ? 2 : 1), "BAD_INDENT", k), d = "";
        }
        r === S.BLOCK_LITERAL ? (f += h + d.slice(l) + b, h = `
`) : d.length > l || b[0] === "	" ? (h === " " ? h = `
` : !m && h === `
` && (h = `

`), f += h + d.slice(l) + b, h = `
`, m = !0) : b === "" ? h === `
` ? f += `
` : h = `
` : (f += h + b, h = " ", m = !1);
    }
    switch (i.chomp) {
        case "-": break;
        case "+":
            for (let p = a; p < o.length; ++p)
                f += `
` + o[p][0].slice(l);
            f[f.length - 1] !== `
` && (f += `
`);
            break;
        default: f += `
`;
    }
    let y = n + i.length + s.source.length;
    return { value: f, type: r, comment: i.comment, range: [n, y, y] };
}
function En({ offset: s, props: e }, t, n) { if (e[0].type !== "block-scalar-header")
    return n(e[0], "IMPOSSIBLE", "Block scalar header not found"), null; let { source: i } = e[0], r = i[0], o = 0, a = "", l = -1; for (let h = 1; h < i.length; ++h) {
    let m = i[h];
    if (!a && (m === "-" || m === "+"))
        a = m;
    else {
        let y = Number(m);
        !o && y ? o = y : l === -1 && (l = s + h);
    }
} l !== -1 && n(l, "UNEXPECTED_TOKEN", `Block scalar header includes extra characters: ${i}`); let c = !1, u = "", f = i.length; for (let h = 1; h < e.length; ++h) {
    let m = e[h];
    switch (m.type) {
        case "space": c = !0;
        case "newline":
            f += m.source.length;
            break;
        case "comment":
            t && !c && n(m, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters"), f += m.source.length, u = m.source.substring(1);
            break;
        case "error":
            n(m, "UNEXPECTED_TOKEN", m.message), f += m.source.length;
            break;
        default: {
            let y = `Unexpected token in block scalar header: ${m.type}`;
            n(m, "UNEXPECTED_TOKEN", y);
            let p = m.source;
            p && typeof p == "string" && (f += p.length);
        }
    }
} return { mode: r, indent: o, chomp: a, comment: u, length: f }; }
function Ln(s) { let e = s.split(/\n( *)/), t = e[0], n = t.match(/^( *)/), r = [n?.[1] ? [n[1], t.slice(n[1].length)] : ["", t]]; for (let o = 1; o < e.length; o += 2)
    r.push([e[o], e[o + 1]]); return r; }
function It(s, e, t) { let { offset: n, type: i, source: r, end: o } = s, a, l, c = (h, m, y) => t(n + h, m, y); switch (i) {
    case "scalar":
        a = S.PLAIN, l = Tn(r, c);
        break;
    case "single-quoted-scalar":
        a = S.QUOTE_SINGLE, l = In(r, c);
        break;
    case "double-quoted-scalar":
        a = S.QUOTE_DOUBLE, l = Cn(r, c);
        break;
    default: return t(s, "UNEXPECTED_TOKEN", `Expected a flow scalar value, but found: ${i}`), { value: "", type: null, comment: "", range: [n, n + r.length, n + r.length] };
} let u = n + r.length, f = se(o, u, e, t); return { value: l, type: a, comment: f.comment, range: [n, u, f.offset] }; }
function Tn(s, e) { let t = ""; switch (s[0]) {
    case "	":
        t = "a tab character";
        break;
    case ",":
        t = "flow indicator character ,";
        break;
    case "%":
        t = "directive indicator character %";
        break;
    case "|":
    case ">": {
        t = `block scalar indicator ${s[0]}`;
        break;
    }
    case "@":
    case "`": {
        t = `reserved character ${s[0]}`;
        break;
    }
} return t && e(0, "BAD_SCALAR_START", `Plain value cannot start with ${t}`), Us(s); }
function In(s, e) { return (s[s.length - 1] !== "'" || s.length === 1) && e(s.length, "MISSING_CHAR", "Missing closing 'quote"), Us(s.slice(1, -1)).replace(/''/g, "'"); }
function Us(s) {
    let e, t;
    try {
        e = new RegExp(`(.*?)(?<![ 	])[ 	]*\r?
`, "sy"), t = new RegExp(`[ 	]*(.*?)(?:(?<![ 	])[ 	]*)?\r?
`, "sy");
    }
    catch {
        e = /(.*?)[ \t]*\r?\n/sy, t = /[ \t]*(.*?)[ \t]*\r?\n/sy;
    }
    let n = e.exec(s);
    if (!n)
        return s;
    let i = n[1], r = " ", o = e.lastIndex;
    for (t.lastIndex = o; n = t.exec(s);)
        n[1] === "" ? r === `
` ? i += r : r = `
` : (i += r + n[1], r = " "), o = t.lastIndex;
    let a = /[ \t]*(.*)/sy;
    return a.lastIndex = o, n = a.exec(s), i + r + (n?.[1] ?? "");
}
function Cn(s, e) {
    let t = "";
    for (let n = 1; n < s.length - 1; ++n) {
        let i = s[n];
        if (!(i === "\r" && s[n + 1] === `
`))
            if (i === `
`) {
                let { fold: r, offset: o } = vn(s, n);
                t += r, n = o;
            }
            else if (i === "\\") {
                let r = s[++n], o = $n[r];
                if (o)
                    t += o;
                else if (r === `
`)
                    for (r = s[n + 1]; r === " " || r === "	";)
                        r = s[++n + 1];
                else if (r === "\r" && s[n + 1] === `
`)
                    for (r = s[++n + 1]; r === " " || r === "	";)
                        r = s[++n + 1];
                else if (r === "x" || r === "u" || r === "U") {
                    let a = { x: 2, u: 4, U: 8 }[r];
                    t += _n(s, n + 1, a, e), n += a;
                }
                else {
                    let a = s.substr(n - 1, 2);
                    e(n - 1, "BAD_DQ_ESCAPE", `Invalid escape sequence ${a}`), t += a;
                }
            }
            else if (i === " " || i === "	") {
                let r = n, o = s[n + 1];
                for (; o === " " || o === "	";)
                    o = s[++n + 1];
                o !== `
` && !(o === "\r" && s[n + 2] === `
`) && (t += n > r ? s.slice(r, n + 1) : i);
            }
            else
                t += i;
    }
    return (s[s.length - 1] !== '"' || s.length === 1) && e(s.length, "MISSING_CHAR", 'Missing closing "quote'), t;
}
function vn(s, e) {
    let t = "", n = s[e + 1];
    for (; (n === " " || n === "	" || n === `
` || n === "\r") && !(n === "\r" && s[e + 2] !== `
`);)
        n === `
` && (t += `
`), e += 1, n = s[e + 1];
    return t || (t = " "), { fold: t, offset: e };
}
var $n = { 0: "\0", a: "\x07", b: "\b", e: "\x1B", f: "\f", n: `
`, r: "\r", t: "	", v: "\v", N: "\x85", _: "\xA0", L: "\u2028", P: "\u2029", " ": " ", '"': '"', "/": "/", "\\": "\\", "	": "	" };
function _n(s, e, t, n) { let i = s.substr(e, t), o = i.length === t && /^[0-9a-fA-F]+$/.test(i) ? parseInt(i, 16) : NaN; if (isNaN(o)) {
    let a = s.substr(e - 2, t + 2);
    return n(e - 2, "BAD_DQ_ESCAPE", `Invalid escape sequence ${a}`), a;
} return String.fromCodePoint(o); }
function Zt(s, e, t, n) { let { value: i, type: r, comment: o, range: a } = e.type === "block-scalar" ? Tt(e, s.options.strict, n) : It(e, s.options.strict, n), l = t ? s.directives.tagName(t.source, f => n(t, "TAG_RESOLVE_FAILED", f)) : null, c = t && l ? Pn(s.schema, i, l, t, n) : e.type === "scalar" ? Mn(s, i, e, n) : s.schema[V], u; try {
    let f = c.resolve(i, h => n(t ?? e, "TAG_RESOLVE_FAILED", h), s.options);
    u = A(f) ? f : new S(f);
}
catch (f) {
    let h = f instanceof Error ? f.message : String(f);
    n(t ?? e, "TAG_RESOLVE_FAILED", h), u = new S(i);
} return u.range = a, u.source = i, r && (u.type = r), l && (u.tag = l), c.format && (u.format = c.format), o && (u.comment = o), u; }
function Pn(s, e, t, n, i) { if (t === "!")
    return s[V]; let r = []; for (let a of s.tags)
    if (!a.collection && a.tag === t)
        if (a.default && a.test)
            r.push(a);
        else
            return a; for (let a of r)
    if (a.test?.test(e))
        return a; let o = s.knownTags[t]; return o && !o.collection ? (s.tags.push(Object.assign({}, o, { default: !1, test: void 0 })), o) : (i(n, "TAG_RESOLVE_FAILED", `Unresolved tag: ${t}`, t !== "tag:yaml.org,2002:str"), s[V]); }
function Mn({ directives: s, schema: e }, t, n, i) { let r = e.tags.find(o => o.default && o.test?.test(t)) || e[V]; if (e.compat) {
    let o = e.compat.find(a => a.default && a.test?.test(t)) ?? e[V];
    if (r.tag !== o.tag) {
        let a = s.tagString(r.tag), l = s.tagString(o.tag), c = `Value may be parsed as either ${a} or ${l}`;
        i(n, "TAG_RESOLVE_FAILED", c, !0);
    }
} return r; }
function Vs(s, e, t) { if (e) {
    t === null && (t = e.length);
    for (let n = t - 1; n >= 0; --n) {
        let i = e[n];
        switch (i.type) {
            case "space":
            case "comment":
            case "newline":
                s -= i.source.length;
                continue;
        }
        for (i = e[++n]; i?.type === "space";)
            s += i.source.length, i = e[++n];
        break;
    }
} return s; }
var Bn = { composeNode: es, composeEmptyNode: Ct };
function es(s, e, t, n) { let { spaceBefore: i, comment: r, anchor: o, tag: a } = t, l, c = !0; switch (e.type) {
    case "alias":
        l = Dn(s, e, n), (o || a) && n(e, "ALIAS_PROPS", "An alias node must not specify any properties");
        break;
    case "scalar":
    case "single-quoted-scalar":
    case "double-quoted-scalar":
    case "block-scalar":
        l = Zt(s, e, a, n), o && (l.anchor = o.source.substring(1));
        break;
    case "block-map":
    case "block-seq":
    case "flow-collection":
        l = Rs(Bn, s, e, a, n), o && (l.anchor = o.source.substring(1));
        break;
    default: {
        let u = e.type === "error" ? e.message : `Unsupported token (type: ${e.type})`;
        n(e, "UNEXPECTED_TOKEN", u), l = Ct(s, e.offset, void 0, null, t, n), c = !1;
    }
} return o && l.anchor === "" && n(o, "BAD_ALIAS", "Anchor cannot be an empty string"), i && (l.spaceBefore = !0), r && (e.type === "scalar" && e.source === "" ? l.comment = r : l.commentBefore = r), s.options.keepSourceTokens && c && (l.srcToken = e), l; }
function Ct(s, e, t, n, { spaceBefore: i, comment: r, anchor: o, tag: a, end: l }, c) { let u = { type: "scalar", offset: Vs(e, t, n), indent: -1, source: "" }, f = Zt(s, u, a, c); return o && (f.anchor = o.source.substring(1), f.anchor === "" && c(o, "BAD_ALIAS", "Anchor cannot be an empty string")), i && (f.spaceBefore = !0), r && (f.comment = r, f.range[2] = l), f; }
function Dn({ options: s }, { offset: e, source: t, end: n }, i) { let r = new G(t.substring(1)); r.source === "" && i(e, "BAD_ALIAS", "Alias cannot be an empty string"), r.source.endsWith(":") && i(e + t.length - 1, "BAD_ALIAS", "Alias ending in : is ambiguous", !0); let o = e + t.length, a = se(n, o, s.strict, i); return r.range = [e, o, a.offset], a.comment && (r.comment = a.comment), r; }
function Ys(s, e, { offset: t, start: n, value: i, end: r }, o) { let a = Object.assign({ _directives: e }, s), l = new R(void 0, a), c = { atRoot: !0, directives: l.directives, options: l.options, schema: l.schema }, u = te(n, { indicator: "doc-start", next: i ?? r?.[0], offset: t, onError: o, startOnNewline: !0 }); u.found && (l.directives.docStart = !0, i && (i.type === "block-map" || i.type === "block-seq") && !u.hasNewline && o(u.end, "MISSING_CHAR", "Block collection cannot start on same line with directives-end marker")), l.contents = i ? es(c, i, u, o) : Ct(c, u.end, n, null, u, o); let f = l.contents.range[2], h = se(r, f, !1, o); return h.comment && (l.comment = h.comment), l.range = [t, f, h.offset], l; }
function We(s) { if (typeof s == "number")
    return [s, s + 1]; if (Array.isArray(s))
    return s.length === 2 ? s : [s[0], s[1]]; let { offset: e, source: t } = s; return [e, e + (typeof t == "string" ? t.length : 1)]; }
function Js(s) {
    let e = "", t = !1, n = !1;
    for (let i = 0; i < s.length; ++i) {
        let r = s[i];
        switch (r[0]) {
            case "#":
                e += (e === "" ? "" : n ? `

` : `
`) + (r.substring(1) || " "), t = !0, n = !1;
                break;
            case "%":
                s[i + 1]?.[0] !== "#" && (i += 1), t = !1;
                break;
            default: t || (n = !0), t = !1;
        }
    }
    return { comment: e, afterEmptyLine: n };
}
var ge = class {
    constructor(e = {}) { this.doc = null, this.atDirectives = !1, this.prelude = [], this.errors = [], this.warnings = [], this.onError = (t, n, i, r) => { let o = We(t); r ? this.warnings.push(new Ne(o, n, i)) : this.errors.push(new x(o, n, i)); }, this.directives = new $({ version: e.version || "1.2" }), this.options = e; }
    decorate(e, t) {
        let { comment: n, afterEmptyLine: i } = Js(this.prelude);
        if (n) {
            let r = e.contents;
            if (t)
                e.comment = e.comment ? `${e.comment}
${n}` : n;
            else if (i || e.directives.docStart || !r)
                e.commentBefore = n;
            else if (T(r) && !r.flow && r.items.length > 0) {
                let o = r.items[0];
                E(o) && (o = o.key);
                let a = o.commentBefore;
                o.commentBefore = a ? `${n}
${a}` : n;
            }
            else {
                let o = r.commentBefore;
                r.commentBefore = o ? `${n}
${o}` : n;
            }
        }
        t ? (Array.prototype.push.apply(e.errors, this.errors), Array.prototype.push.apply(e.warnings, this.warnings)) : (e.errors = this.errors, e.warnings = this.warnings), this.prelude = [], this.errors = [], this.warnings = [];
    }
    streamInfo() { return { comment: Js(this.prelude).comment, directives: this.directives, errors: this.errors, warnings: this.warnings }; }
    *compose(e, t = !1, n = -1) { for (let i of e)
        yield* this.next(i); yield* this.end(t, n); }
    *next(e) {
        switch (e.type) {
            case "directive":
                this.directives.add(e.source, (t, n, i) => { let r = We(e); r[0] += t, this.onError(r, "BAD_DIRECTIVE", n, i); }), this.prelude.push(e.source), this.atDirectives = !0;
                break;
            case "document": {
                let t = Ys(this.options, this.directives, e, this.onError);
                this.atDirectives && !t.directives.docStart && this.onError(e, "MISSING_CHAR", "Missing directives-end/doc-start indicator line"), this.decorate(t, !1), this.doc && (yield this.doc), this.doc = t, this.atDirectives = !1;
                break;
            }
            case "byte-order-mark":
            case "space": break;
            case "comment":
            case "newline":
                this.prelude.push(e.source);
                break;
            case "error": {
                let t = e.source ? `${e.message}: ${JSON.stringify(e.source)}` : e.message, n = new x(We(e), "UNEXPECTED_TOKEN", t);
                this.atDirectives || !this.doc ? this.errors.push(n) : this.doc.errors.push(n);
                break;
            }
            case "doc-end": {
                if (!this.doc) {
                    let n = "Unexpected doc-end without preceding document";
                    this.errors.push(new x(We(e), "UNEXPECTED_TOKEN", n));
                    break;
                }
                this.doc.directives.docEnd = !0;
                let t = se(e.end, e.offset + e.source.length, this.doc.options.strict, this.onError);
                if (this.decorate(this.doc, !0), t.comment) {
                    let n = this.doc.comment;
                    this.doc.comment = n ? `${n}
${t.comment}` : t.comment;
                }
                this.doc.range[2] = t.offset;
                break;
            }
            default: this.errors.push(new x(We(e), "UNEXPECTED_TOKEN", `Unsupported token ${e.type}`));
        }
    }
    *end(e = !1, t = -1) { if (this.doc)
        this.decorate(this.doc, !0), yield this.doc, this.doc = null;
    else if (e) {
        let n = Object.assign({ _directives: this.directives }, this.options), i = new R(void 0, n);
        this.atDirectives && this.onError(t, "MISSING_CHAR", "Missing directives-end indicator line"), i.range = [0, t, t], this.decorate(i, !1), yield i;
    } }
};
var _t = {};
Dt(_t, { BOM: () => He, DOCUMENT: () => Xe, FLOW_END: () => ze, SCALAR: () => Be, createScalarToken: () => Gs, isCollection: () => Kn, isScalar: () => qn, prettyToken: () => Fn, resolveAsScalar: () => Qs, setScalarValue: () => Ws, stringify: () => Xs, tokenType: () => ns, visit: () => ye });
function Qs(s, e = !0, t) { if (s) {
    let n = (i, r, o) => { let a = typeof i == "number" ? i : Array.isArray(i) ? i[0] : i.offset; if (t)
        t(a, r, o);
    else
        throw new x([a, a + 1], r, o); };
    switch (s.type) {
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar": return It(s, e, n);
        case "block-scalar": return Tt(s, e, n);
    }
} return null; }
function Gs(s, e) {
    let { implicitKey: t = !1, indent: n, inFlow: i = !1, offset: r = -1, type: o = "PLAIN" } = e, a = le({ type: o, value: s }, { implicitKey: t, indent: n > 0 ? " ".repeat(n) : "", inFlow: i, options: { blockQuote: !0, lineWidth: -1 } }), l = e.end ?? [{ type: "newline", offset: -1, indent: n, source: `
` }];
    switch (a[0]) {
        case "|":
        case ">": {
            let c = a.indexOf(`
`), u = a.substring(0, c), f = a.substring(c + 1) + `
`, h = [{ type: "block-scalar-header", offset: r, indent: n, source: u }];
            return Hs(h, l) || h.push({ type: "newline", offset: -1, indent: n, source: `
` }), { type: "block-scalar", offset: r, indent: n, props: h, source: f };
        }
        case '"': return { type: "double-quoted-scalar", offset: r, indent: n, source: a, end: l };
        case "'": return { type: "single-quoted-scalar", offset: r, indent: n, source: a, end: l };
        default: return { type: "scalar", offset: r, indent: n, source: a, end: l };
    }
}
function Ws(s, e, t = {}) { let { afterKey: n = !1, implicitKey: i = !1, inFlow: r = !1, type: o } = t, a = "indent" in s ? s.indent : null; if (n && typeof a == "number" && (a += 2), !o)
    switch (s.type) {
        case "single-quoted-scalar":
            o = "QUOTE_SINGLE";
            break;
        case "double-quoted-scalar":
            o = "QUOTE_DOUBLE";
            break;
        case "block-scalar": {
            let c = s.props[0];
            if (c.type !== "block-scalar-header")
                throw new Error("Invalid block scalar header");
            o = c.source[0] === ">" ? "BLOCK_FOLDED" : "BLOCK_LITERAL";
            break;
        }
        default: o = "PLAIN";
    } let l = le({ type: o, value: e }, { implicitKey: i || a === null, indent: a !== null && a > 0 ? " ".repeat(a) : "", inFlow: r, options: { blockQuote: !0, lineWidth: -1 } }); switch (l[0]) {
    case "|":
    case ">":
        jn(s, l);
        break;
    case '"':
        ts(s, l, "double-quoted-scalar");
        break;
    case "'":
        ts(s, l, "single-quoted-scalar");
        break;
    default: ts(s, l, "scalar");
} }
function jn(s, e) {
    let t = e.indexOf(`
`), n = e.substring(0, t), i = e.substring(t + 1) + `
`;
    if (s.type === "block-scalar") {
        let r = s.props[0];
        if (r.type !== "block-scalar-header")
            throw new Error("Invalid block scalar header");
        r.source = n, s.source = i;
    }
    else {
        let { offset: r } = s, o = "indent" in s ? s.indent : -1, a = [{ type: "block-scalar-header", offset: r, indent: o, source: n }];
        Hs(a, "end" in s ? s.end : void 0) || a.push({ type: "newline", offset: -1, indent: o, source: `
` });
        for (let l of Object.keys(s))
            l !== "type" && l !== "offset" && delete s[l];
        Object.assign(s, { type: "block-scalar", indent: o, props: a, source: i });
    }
}
function Hs(s, e) { if (e)
    for (let t of e)
        switch (t.type) {
            case "space":
            case "comment":
                s.push(t);
                break;
            case "newline": return s.push(t), !0;
        } return !1; }
function ts(s, e, t) {
    switch (s.type) {
        case "scalar":
        case "double-quoted-scalar":
        case "single-quoted-scalar":
            s.type = t, s.source = e;
            break;
        case "block-scalar": {
            let n = s.props.slice(1), i = e.length;
            s.props[0].type === "block-scalar-header" && (i -= s.props[0].source.length);
            for (let r of n)
                r.offset += i;
            delete s.props, Object.assign(s, { type: t, source: e, end: n });
            break;
        }
        case "block-map":
        case "block-seq": {
            let i = { type: "newline", offset: s.offset + e.length, indent: s.indent, source: `
` };
            delete s.items, Object.assign(s, { type: t, source: e, end: [i] });
            break;
        }
        default: {
            let n = "indent" in s ? s.indent : -1, i = "end" in s && Array.isArray(s.end) ? s.end.filter(r => r.type === "space" || r.type === "comment" || r.type === "newline") : [];
            for (let r of Object.keys(s))
                r !== "type" && r !== "offset" && delete s[r];
            Object.assign(s, { type: t, indent: n, source: e, end: i });
        }
    }
}
var Xs = s => "type" in s ? $t(s) : vt(s);
function $t(s) { switch (s.type) {
    case "block-scalar": {
        let e = "";
        for (let t of s.props)
            e += $t(t);
        return e + s.source;
    }
    case "block-map":
    case "block-seq": {
        let e = "";
        for (let t of s.items)
            e += vt(t);
        return e;
    }
    case "flow-collection": {
        let e = s.start.source;
        for (let t of s.items)
            e += vt(t);
        for (let t of s.end)
            e += t.source;
        return e;
    }
    case "document": {
        let e = vt(s);
        if (s.end)
            for (let t of s.end)
                e += t.source;
        return e;
    }
    default: {
        let e = s.source;
        if ("end" in s && s.end)
            for (let t of s.end)
                e += t.source;
        return e;
    }
} }
function vt({ start: s, key: e, sep: t, value: n }) { let i = ""; for (let r of s)
    i += r.source; if (e && (i += $t(e)), t)
    for (let r of t)
        i += r.source; return n && (i += $t(n)), i; }
var ss = Symbol("break visit"), xn = Symbol("skip children"), zs = Symbol("remove item");
function ye(s, e) { "type" in s && s.type === "document" && (s = { start: s.start, value: s.value }), Zs(Object.freeze([]), s, e); }
ye.BREAK = ss;
ye.SKIP = xn;
ye.REMOVE = zs;
ye.itemAtPath = (s, e) => { let t = s; for (let [n, i] of e) {
    let r = t?.[n];
    if (r && "items" in r)
        t = r.items[i];
    else
        return;
} return t; };
ye.parentCollection = (s, e) => { let t = ye.itemAtPath(s, e.slice(0, -1)), n = e[e.length - 1][0], i = t?.[n]; if (i && "items" in i)
    return i; throw new Error("Parent collection not found"); };
function Zs(s, e, t) { let n = t(e, s); if (typeof n == "symbol")
    return n; for (let i of ["key", "value"]) {
    let r = e[i];
    if (r && "items" in r) {
        for (let o = 0; o < r.items.length; ++o) {
            let a = Zs(Object.freeze(s.concat([[i, o]])), r.items[o], t);
            if (typeof a == "number")
                o = a - 1;
            else {
                if (a === ss)
                    return ss;
                a === zs && (r.items.splice(o, 1), o -= 1);
            }
        }
        typeof n == "function" && i === "key" && (n = n(e, s));
    }
} return typeof n == "function" ? n(e, s) : n; }
var He = "\uFEFF", Xe = "", ze = "", Be = "", Kn = s => !!s && "items" in s, qn = s => !!s && (s.type === "scalar" || s.type === "single-quoted-scalar" || s.type === "double-quoted-scalar" || s.type === "block-scalar");
function Fn(s) { switch (s) {
    case He: return "<BOM>";
    case Xe: return "<DOC>";
    case ze: return "<FLOW_END>";
    case Be: return "<SCALAR>";
    default: return JSON.stringify(s);
} }
function ns(s) {
    switch (s) {
        case He: return "byte-order-mark";
        case Xe: return "doc-mode";
        case ze: return "flow-error-end";
        case Be: return "scalar";
        case "---": return "doc-start";
        case "...": return "doc-end";
        case "":
        case `
`:
        case `\r
`:
            return "newline";
        case "-": return "seq-item-ind";
        case "?": return "explicit-key-ind";
        case ":": return "map-value-ind";
        case "{": return "flow-map-start";
        case "}": return "flow-map-end";
        case "[": return "flow-seq-start";
        case "]": return "flow-seq-end";
        case ",": return "comma";
    }
    switch (s[0]) {
        case " ":
        case "	": return "space";
        case "#": return "comment";
        case "%": return "directive-line";
        case "*": return "alias";
        case "&": return "anchor";
        case "!": return "tag";
        case "'": return "single-quoted-scalar";
        case '"': return "double-quoted-scalar";
        case "|":
        case ">": return "block-scalar-header";
    }
    return null;
}
function J(s) {
    switch (s) {
        case void 0:
        case " ":
        case `
`:
        case "\r":
        case "	": return !0;
        default: return !1;
    }
}
var en = "0123456789ABCDEFabcdef".split(""), Rn = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-#;/?:@&=+$_.!~*'()".split(""), is = ",[]{}".split(""), Un = ` ,[]{}
\r	`.split(""), rs = s => !s || Un.includes(s), Ae = class {
    constructor() { this.atEnd = !1, this.blockScalarIndent = -1, this.blockScalarKeep = !1, this.buffer = "", this.flowKey = !1, this.flowLevel = 0, this.indentNext = 0, this.indentValue = 0, this.lineEndPos = null, this.next = null, this.pos = 0; }
    *lex(e, t = !1) { e && (this.buffer = this.buffer ? this.buffer + e : e, this.lineEndPos = null), this.atEnd = !t; let n = this.next ?? "stream"; for (; n && (t || this.hasChars(1));)
        n = yield* this.parseNext(n); }
    atLineEnd() {
        let e = this.pos, t = this.buffer[e];
        for (; t === " " || t === "	";)
            t = this.buffer[++e];
        return !t || t === "#" || t === `
` ? !0 : t === "\r" ? this.buffer[e + 1] === `
` : !1;
    }
    charAt(e) { return this.buffer[this.pos + e]; }
    continueScalar(e) {
        let t = this.buffer[e];
        if (this.indentNext > 0) {
            let n = 0;
            for (; t === " ";)
                t = this.buffer[++n + e];
            if (t === "\r") {
                let i = this.buffer[n + e + 1];
                if (i === `
` || !i && !this.atEnd)
                    return e + n + 1;
            }
            return t === `
` || n >= this.indentNext || !t && !this.atEnd ? e + n : -1;
        }
        if (t === "-" || t === ".") {
            let n = this.buffer.substr(e, 3);
            if ((n === "---" || n === "...") && J(this.buffer[e + 3]))
                return -1;
        }
        return e;
    }
    getLine() {
        let e = this.lineEndPos;
        return (typeof e != "number" || e !== -1 && e < this.pos) && (e = this.buffer.indexOf(`
`, this.pos), this.lineEndPos = e), e === -1 ? this.atEnd ? this.buffer.substring(this.pos) : null : (this.buffer[e - 1] === "\r" && (e -= 1), this.buffer.substring(this.pos, e));
    }
    hasChars(e) { return this.pos + e <= this.buffer.length; }
    setNext(e) { return this.buffer = this.buffer.substring(this.pos), this.pos = 0, this.lineEndPos = null, this.next = e, null; }
    peek(e) { return this.buffer.substr(this.pos, e); }
    *parseNext(e) { switch (e) {
        case "stream": return yield* this.parseStream();
        case "line-start": return yield* this.parseLineStart();
        case "block-start": return yield* this.parseBlockStart();
        case "doc": return yield* this.parseDocument();
        case "flow": return yield* this.parseFlowCollection();
        case "quoted-scalar": return yield* this.parseQuotedScalar();
        case "block-scalar": return yield* this.parseBlockScalar();
        case "plain-scalar": return yield* this.parsePlainScalar();
    } }
    *parseStream() { let e = this.getLine(); if (e === null)
        return this.setNext("stream"); if (e[0] === He && (yield* this.pushCount(1), e = e.substring(1)), e[0] === "%") {
        let t = e.length, n = e.indexOf("#");
        if (n !== -1) {
            let r = e[n - 1];
            (r === " " || r === "	") && (t = n - 1);
        }
        for (;;) {
            let r = e[t - 1];
            if (r === " " || r === "	")
                t -= 1;
            else
                break;
        }
        let i = (yield* this.pushCount(t)) + (yield* this.pushSpaces(!0));
        return yield* this.pushCount(e.length - i), this.pushNewline(), "stream";
    } if (this.atLineEnd()) {
        let t = yield* this.pushSpaces(!0);
        return yield* this.pushCount(e.length - t), yield* this.pushNewline(), "stream";
    } return yield Xe, yield* this.parseLineStart(); }
    *parseLineStart() { let e = this.charAt(0); if (!e && !this.atEnd)
        return this.setNext("line-start"); if (e === "-" || e === ".") {
        if (!this.atEnd && !this.hasChars(4))
            return this.setNext("line-start");
        let t = this.peek(3);
        if (t === "---" && J(this.charAt(3)))
            return yield* this.pushCount(3), this.indentValue = 0, this.indentNext = 0, "doc";
        if (t === "..." && J(this.charAt(3)))
            return yield* this.pushCount(3), "stream";
    } return this.indentValue = yield* this.pushSpaces(!1), this.indentNext > this.indentValue && !J(this.charAt(1)) && (this.indentNext = this.indentValue), yield* this.parseBlockStart(); }
    *parseBlockStart() { let [e, t] = this.peek(2); if (!t && !this.atEnd)
        return this.setNext("block-start"); if ((e === "-" || e === "?" || e === ":") && J(t)) {
        let n = (yield* this.pushCount(1)) + (yield* this.pushSpaces(!0));
        return this.indentNext = this.indentValue + 1, this.indentValue += n, yield* this.parseBlockStart();
    } return "doc"; }
    *parseDocument() { yield* this.pushSpaces(!0); let e = this.getLine(); if (e === null)
        return this.setNext("doc"); let t = yield* this.pushIndicators(); switch (e[t]) {
        case "#": yield* this.pushCount(e.length - t);
        case void 0: return yield* this.pushNewline(), yield* this.parseLineStart();
        case "{":
        case "[": return yield* this.pushCount(1), this.flowKey = !1, this.flowLevel = 1, "flow";
        case "}":
        case "]": return yield* this.pushCount(1), "doc";
        case "*": return yield* this.pushUntil(rs), "doc";
        case '"':
        case "'": return yield* this.parseQuotedScalar();
        case "|":
        case ">": return t += yield* this.parseBlockScalarHeader(), t += yield* this.pushSpaces(!0), yield* this.pushCount(e.length - t), yield* this.pushNewline(), yield* this.parseBlockScalar();
        default: return yield* this.parsePlainScalar();
    } }
    *parseFlowCollection() { let e, t, n = -1; do
        e = yield* this.pushNewline(), e > 0 ? (t = yield* this.pushSpaces(!1), this.indentValue = n = t) : t = 0, t += yield* this.pushSpaces(!0);
    while (e + t > 0); let i = this.getLine(); if (i === null)
        return this.setNext("flow"); if ((n !== -1 && n < this.indentNext && i[0] !== "#" || n === 0 && (i.startsWith("---") || i.startsWith("...")) && J(i[3])) && !(n === this.indentNext - 1 && this.flowLevel === 1 && (i[0] === "]" || i[0] === "}")))
        return this.flowLevel = 0, yield ze, yield* this.parseLineStart(); let r = 0; for (; i[r] === ",";)
        r += yield* this.pushCount(1), r += yield* this.pushSpaces(!0), this.flowKey = !1; switch (r += yield* this.pushIndicators(), i[r]) {
        case void 0: return "flow";
        case "#": return yield* this.pushCount(i.length - r), "flow";
        case "{":
        case "[": return yield* this.pushCount(1), this.flowKey = !1, this.flowLevel += 1, "flow";
        case "}":
        case "]": return yield* this.pushCount(1), this.flowKey = !0, this.flowLevel -= 1, this.flowLevel ? "flow" : "doc";
        case "*": return yield* this.pushUntil(rs), "flow";
        case '"':
        case "'": return this.flowKey = !0, yield* this.parseQuotedScalar();
        case ":": {
            let o = this.charAt(1);
            if (this.flowKey || J(o) || o === ",")
                return this.flowKey = !1, yield* this.pushCount(1), yield* this.pushSpaces(!0), "flow";
        }
        default: return this.flowKey = !1, yield* this.parsePlainScalar();
    } }
    *parseQuotedScalar() {
        let e = this.charAt(0), t = this.buffer.indexOf(e, this.pos + 1);
        if (e === "'")
            for (; t !== -1 && this.buffer[t + 1] === "'";)
                t = this.buffer.indexOf("'", t + 2);
        else
            for (; t !== -1;) {
                let r = 0;
                for (; this.buffer[t - 1 - r] === "\\";)
                    r += 1;
                if (r % 2 === 0)
                    break;
                t = this.buffer.indexOf('"', t + 1);
            }
        let n = this.buffer.substring(0, t), i = n.indexOf(`
`, this.pos);
        if (i !== -1) {
            for (; i !== -1;) {
                let r = this.continueScalar(i + 1);
                if (r === -1)
                    break;
                i = n.indexOf(`
`, r);
            }
            i !== -1 && (t = i - (n[i - 1] === "\r" ? 2 : 1));
        }
        if (t === -1) {
            if (!this.atEnd)
                return this.setNext("quoted-scalar");
            t = this.buffer.length;
        }
        return yield* this.pushToIndex(t + 1, !1), this.flowLevel ? "flow" : "doc";
    }
    *parseBlockScalarHeader() { this.blockScalarIndent = -1, this.blockScalarKeep = !1; let e = this.pos; for (;;) {
        let t = this.buffer[++e];
        if (t === "+")
            this.blockScalarKeep = !0;
        else if (t > "0" && t <= "9")
            this.blockScalarIndent = Number(t) - 1;
        else if (t !== "-")
            break;
    } return yield* this.pushUntil(t => J(t) || t === "#"); }
    *parseBlockScalar() {
        let e = this.pos - 1, t = 0, n;
        e: for (let i = this.pos; n = this.buffer[i]; ++i)
            switch (n) {
                case " ":
                    t += 1;
                    break;
                case `
`:
                    e = i, t = 0;
                    break;
                case "\r": {
                    let r = this.buffer[i + 1];
                    if (!r && !this.atEnd)
                        return this.setNext("block-scalar");
                    if (r === `
`)
                        break;
                }
                default: break e;
            }
        if (!n && !this.atEnd)
            return this.setNext("block-scalar");
        if (t >= this.indentNext) {
            this.blockScalarIndent === -1 ? this.indentNext = t : this.indentNext += this.blockScalarIndent;
            do {
                let i = this.continueScalar(e + 1);
                if (i === -1)
                    break;
                e = this.buffer.indexOf(`
`, i);
            } while (e !== -1);
            if (e === -1) {
                if (!this.atEnd)
                    return this.setNext("block-scalar");
                e = this.buffer.length;
            }
        }
        if (!this.blockScalarKeep)
            do {
                let i = e - 1, r = this.buffer[i];
                r === "\r" && (r = this.buffer[--i]);
                let o = i;
                for (; r === " " || r === "	";)
                    r = this.buffer[--i];
                if (r === `
` && i >= this.pos && i + 1 + t > o)
                    e = i;
                else
                    break;
            } while (!0);
        return yield Be, yield* this.pushToIndex(e + 1, !0), yield* this.parseLineStart();
    }
    *parsePlainScalar() {
        let e = this.flowLevel > 0, t = this.pos - 1, n = this.pos - 1, i;
        for (; i = this.buffer[++n];)
            if (i === ":") {
                let r = this.buffer[n + 1];
                if (J(r) || e && r === ",")
                    break;
                t = n;
            }
            else if (J(i)) {
                let r = this.buffer[n + 1];
                if (i === "\r" && (r === `
` ? (n += 1, i = `
`, r = this.buffer[n + 1]) : t = n), r === "#" || e && is.includes(r))
                    break;
                if (i === `
`) {
                    let o = this.continueScalar(n + 1);
                    if (o === -1)
                        break;
                    n = Math.max(n, o - 2);
                }
            }
            else {
                if (e && is.includes(i))
                    break;
                t = n;
            }
        return !i && !this.atEnd ? this.setNext("plain-scalar") : (yield Be, yield* this.pushToIndex(t + 1, !0), e ? "flow" : "doc");
    }
    *pushCount(e) { return e > 0 ? (yield this.buffer.substr(this.pos, e), this.pos += e, e) : 0; }
    *pushToIndex(e, t) { let n = this.buffer.slice(this.pos, e); return n ? (yield n, this.pos += n.length, n.length) : (t && (yield ""), 0); }
    *pushIndicators() { switch (this.charAt(0)) {
        case "!": return (yield* this.pushTag()) + (yield* this.pushSpaces(!0)) + (yield* this.pushIndicators());
        case "&": return (yield* this.pushUntil(rs)) + (yield* this.pushSpaces(!0)) + (yield* this.pushIndicators());
        case "-":
        case "?":
        case ":": {
            let e = this.flowLevel > 0, t = this.charAt(1);
            if (J(t) || e && is.includes(t))
                return e ? this.flowKey && (this.flowKey = !1) : this.indentNext = this.indentValue + 1, (yield* this.pushCount(1)) + (yield* this.pushSpaces(!0)) + (yield* this.pushIndicators());
        }
    } return 0; }
    *pushTag() { if (this.charAt(1) === "<") {
        let e = this.pos + 2, t = this.buffer[e];
        for (; !J(t) && t !== ">";)
            t = this.buffer[++e];
        return yield* this.pushToIndex(t === ">" ? e + 1 : e, !1);
    }
    else {
        let e = this.pos + 1, t = this.buffer[e];
        for (; t;)
            if (Rn.includes(t))
                t = this.buffer[++e];
            else if (t === "%" && en.includes(this.buffer[e + 1]) && en.includes(this.buffer[e + 2]))
                t = this.buffer[e += 3];
            else
                break;
        return yield* this.pushToIndex(e, !1);
    } }
    *pushNewline() {
        let e = this.buffer[this.pos];
        return e === `
` ? yield* this.pushCount(1) : e === "\r" && this.charAt(1) === `
` ? yield* this.pushCount(2) : 0;
    }
    *pushSpaces(e) { let t = this.pos - 1, n; do
        n = this.buffer[++t];
    while (n === " " || e && n === "	"); let i = t - this.pos; return i > 0 && (yield this.buffer.substr(this.pos, i), this.pos = t), i; }
    *pushUntil(e) { let t = this.pos, n = this.buffer[t]; for (; !e(n);)
        n = this.buffer[++t]; return yield* this.pushToIndex(t, !1); }
};
var Oe = class {
    constructor() { this.lineStarts = [], this.addNewLine = e => this.lineStarts.push(e), this.linePos = e => { let t = 0, n = this.lineStarts.length; for (; t < n;) {
        let r = t + n >> 1;
        this.lineStarts[r] < e ? t = r + 1 : n = r;
    } if (this.lineStarts[t] === e)
        return { line: t + 1, col: 1 }; if (t === 0)
        return { line: 0, col: e }; let i = this.lineStarts[t - 1]; return { line: t, col: e - i + 1 }; }; }
};
function Z(s, e) { for (let t = 0; t < s.length; ++t)
    if (s[t].type === e)
        return !0; return !1; }
function tn(s) { for (let e = 0; e < s.length; ++e)
    switch (s[e].type) {
        case "space":
        case "comment":
        case "newline": break;
        default: return e;
    } return -1; }
function nn(s) { switch (s?.type) {
    case "alias":
    case "scalar":
    case "single-quoted-scalar":
    case "double-quoted-scalar":
    case "flow-collection": return !0;
    default: return !1;
} }
function Pt(s) { switch (s.type) {
    case "document": return s.start;
    case "block-map": {
        let e = s.items[s.items.length - 1];
        return e.sep ?? e.start;
    }
    case "block-seq": return s.items[s.items.length - 1].start;
    default: return [];
} }
function De(s) { if (s.length === 0)
    return []; let e = s.length; e: for (; --e >= 0;)
    switch (s[e].type) {
        case "doc-start":
        case "explicit-key-ind":
        case "map-value-ind":
        case "seq-item-ind":
        case "newline": break e;
    } for (; s[++e]?.type === "space";)
    ; return s.splice(e, s.length); }
function sn(s) { if (s.start.type === "flow-seq-start")
    for (let e of s.items)
        e.sep && !e.value && !Z(e.start, "explicit-key-ind") && !Z(e.sep, "map-value-ind") && (e.key && (e.value = e.key), delete e.key, nn(e.value) ? e.value.end ? Array.prototype.push.apply(e.value.end, e.sep) : e.value.end = e.sep : Array.prototype.push.apply(e.start, e.sep), delete e.sep); }
var be = class {
    constructor(e) { this.atNewLine = !0, this.atScalar = !1, this.indent = 0, this.offset = 0, this.onKeyLine = !1, this.stack = [], this.source = "", this.type = "", this.lexer = new Ae, this.onNewLine = e; }
    *parse(e, t = !1) { this.onNewLine && this.offset === 0 && this.onNewLine(0); for (let n of this.lexer.lex(e, t))
        yield* this.next(n); t || (yield* this.end()); }
    *next(e) { if (this.source = e, this.atScalar) {
        this.atScalar = !1, yield* this.step(), this.offset += e.length;
        return;
    } let t = ns(e); if (t)
        if (t === "scalar")
            this.atNewLine = !1, this.atScalar = !0, this.type = "scalar";
        else {
            switch (this.type = t, yield* this.step(), t) {
                case "newline":
                    this.atNewLine = !0, this.indent = 0, this.onNewLine && this.onNewLine(this.offset + e.length);
                    break;
                case "space":
                    this.atNewLine && e[0] === " " && (this.indent += e.length);
                    break;
                case "explicit-key-ind":
                case "map-value-ind":
                case "seq-item-ind":
                    this.atNewLine && (this.indent += e.length);
                    break;
                case "doc-mode":
                case "flow-error-end": return;
                default: this.atNewLine = !1;
            }
            this.offset += e.length;
        }
    else {
        let n = `Not a YAML token: ${e}`;
        yield* this.pop({ type: "error", offset: this.offset, message: n, source: e }), this.offset += e.length;
    } }
    *end() { for (; this.stack.length > 0;)
        yield* this.pop(); }
    get sourceToken() { return { type: this.type, offset: this.offset, indent: this.indent, source: this.source }; }
    *step() { let e = this.peek(1); if (this.type === "doc-end" && (!e || e.type !== "doc-end")) {
        for (; this.stack.length > 0;)
            yield* this.pop();
        this.stack.push({ type: "doc-end", offset: this.offset, source: this.source });
        return;
    } if (!e)
        return yield* this.stream(); switch (e.type) {
        case "document": return yield* this.document(e);
        case "alias":
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar": return yield* this.scalar(e);
        case "block-scalar": return yield* this.blockScalar(e);
        case "block-map": return yield* this.blockMap(e);
        case "block-seq": return yield* this.blockSequence(e);
        case "flow-collection": return yield* this.flowCollection(e);
        case "doc-end": return yield* this.documentEnd(e);
    } yield* this.pop(); }
    peek(e) { return this.stack[this.stack.length - e]; }
    *pop(e) { let t = e ?? this.stack.pop(); if (t)
        if (this.stack.length === 0)
            yield t;
        else {
            let n = this.peek(1);
            switch (t.type === "block-scalar" ? t.indent = "indent" in n ? n.indent : 0 : t.type === "flow-collection" && n.type === "document" && (t.indent = 0), t.type === "flow-collection" && sn(t), n.type) {
                case "document":
                    n.value = t;
                    break;
                case "block-scalar":
                    n.props.push(t);
                    break;
                case "block-map": {
                    let i = n.items[n.items.length - 1];
                    if (i.value) {
                        n.items.push({ start: [], key: t, sep: [] }), this.onKeyLine = !0;
                        return;
                    }
                    else if (i.sep)
                        i.value = t;
                    else {
                        Object.assign(i, { key: t, sep: [] }), this.onKeyLine = !Z(i.start, "explicit-key-ind");
                        return;
                    }
                    break;
                }
                case "block-seq": {
                    let i = n.items[n.items.length - 1];
                    i.value ? n.items.push({ start: [], value: t }) : i.value = t;
                    break;
                }
                case "flow-collection": {
                    let i = n.items[n.items.length - 1];
                    !i || i.value ? n.items.push({ start: [], key: t, sep: [] }) : i.sep ? i.value = t : Object.assign(i, { key: t, sep: [] });
                    return;
                }
                default: yield* this.pop(), yield* this.pop(t);
            }
            if ((n.type === "document" || n.type === "block-map" || n.type === "block-seq") && (t.type === "block-map" || t.type === "block-seq")) {
                let i = t.items[t.items.length - 1];
                i && !i.sep && !i.value && i.start.length > 0 && tn(i.start) === -1 && (t.indent === 0 || i.start.every(r => r.type !== "comment" || r.indent < t.indent)) && (n.type === "document" ? n.end = i.start : n.items.push({ start: i.start }), t.items.splice(-1, 1));
            }
        }
    else {
        let n = "Tried to pop an empty stack";
        yield { type: "error", offset: this.offset, source: "", message: n };
    } }
    *stream() { switch (this.type) {
        case "directive-line":
            yield { type: "directive", offset: this.offset, source: this.source };
            return;
        case "byte-order-mark":
        case "space":
        case "comment":
        case "newline":
            yield this.sourceToken;
            return;
        case "doc-mode":
        case "doc-start": {
            let e = { type: "document", offset: this.offset, start: [] };
            this.type === "doc-start" && e.start.push(this.sourceToken), this.stack.push(e);
            return;
        }
    } yield { type: "error", offset: this.offset, message: `Unexpected ${this.type} token in YAML stream`, source: this.source }; }
    *document(e) { if (e.value)
        return yield* this.lineEnd(e); switch (this.type) {
        case "doc-start": {
            tn(e.start) !== -1 ? (yield* this.pop(), yield* this.step()) : e.start.push(this.sourceToken);
            return;
        }
        case "anchor":
        case "tag":
        case "space":
        case "comment":
        case "newline":
            e.start.push(this.sourceToken);
            return;
    } let t = this.startBlockValue(e); t ? this.stack.push(t) : yield { type: "error", offset: this.offset, message: `Unexpected ${this.type} token in YAML document`, source: this.source }; }
    *scalar(e) { if (this.type === "map-value-ind") {
        let t = Pt(this.peek(2)), n = De(t), i;
        e.end ? (i = e.end, i.push(this.sourceToken), delete e.end) : i = [this.sourceToken];
        let r = { type: "block-map", offset: e.offset, indent: e.indent, items: [{ start: n, key: e, sep: i }] };
        this.onKeyLine = !0, this.stack[this.stack.length - 1] = r;
    }
    else
        yield* this.lineEnd(e); }
    *blockScalar(e) {
        switch (this.type) {
            case "space":
            case "comment":
            case "newline":
                e.props.push(this.sourceToken);
                return;
            case "scalar":
                if (e.source = this.source, this.atNewLine = !0, this.indent = 0, this.onNewLine) {
                    let t = this.source.indexOf(`
`) + 1;
                    for (; t !== 0;)
                        this.onNewLine(this.offset + t), t = this.source.indexOf(`
`, t) + 1;
                }
                yield* this.pop();
                break;
            default: yield* this.pop(), yield* this.step();
        }
    }
    *blockMap(e) { let t = e.items[e.items.length - 1]; switch (this.type) {
        case "newline":
            if (this.onKeyLine = !1, t.value) {
                let n = "end" in t.value ? t.value.end : void 0;
                (Array.isArray(n) ? n[n.length - 1] : void 0)?.type === "comment" ? n?.push(this.sourceToken) : e.items.push({ start: [this.sourceToken] });
            }
            else
                t.sep ? t.sep.push(this.sourceToken) : t.start.push(this.sourceToken);
            return;
        case "space":
        case "comment":
            if (t.value)
                e.items.push({ start: [this.sourceToken] });
            else if (t.sep)
                t.sep.push(this.sourceToken);
            else {
                if (this.atIndentedComment(t.start, e.indent)) {
                    let i = e.items[e.items.length - 2]?.value?.end;
                    if (Array.isArray(i)) {
                        Array.prototype.push.apply(i, t.start), i.push(this.sourceToken), e.items.pop();
                        return;
                    }
                }
                t.start.push(this.sourceToken);
            }
            return;
    } if (this.indent >= e.indent) {
        let n = !this.onKeyLine && this.indent === e.indent && t.sep, i = [];
        if (n && t.sep && !t.value) {
            let r = [];
            for (let o = 0; o < t.sep.length; ++o) {
                let a = t.sep[o];
                switch (a.type) {
                    case "newline":
                        r.push(o);
                        break;
                    case "space": break;
                    case "comment":
                        a.indent > e.indent && (r.length = 0);
                        break;
                    default: r.length = 0;
                }
            }
            r.length >= 2 && (i = t.sep.splice(r[1]));
        }
        switch (this.type) {
            case "anchor":
            case "tag":
                n || t.value ? (i.push(this.sourceToken), e.items.push({ start: i }), this.onKeyLine = !0) : t.sep ? t.sep.push(this.sourceToken) : t.start.push(this.sourceToken);
                return;
            case "explicit-key-ind":
                !t.sep && !Z(t.start, "explicit-key-ind") ? t.start.push(this.sourceToken) : n || t.value ? (i.push(this.sourceToken), e.items.push({ start: i })) : this.stack.push({ type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: [this.sourceToken] }] }), this.onKeyLine = !0;
                return;
            case "map-value-ind":
                if (Z(t.start, "explicit-key-ind"))
                    if (t.sep)
                        if (t.value)
                            e.items.push({ start: [], key: null, sep: [this.sourceToken] });
                        else if (Z(t.sep, "map-value-ind"))
                            this.stack.push({ type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: i, key: null, sep: [this.sourceToken] }] });
                        else if (nn(t.key) && !Z(t.sep, "newline")) {
                            let r = De(t.start), o = t.key, a = t.sep;
                            a.push(this.sourceToken), delete t.key, delete t.sep, this.stack.push({ type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: r, key: o, sep: a }] });
                        }
                        else
                            i.length > 0 ? t.sep = t.sep.concat(i, this.sourceToken) : t.sep.push(this.sourceToken);
                    else if (Z(t.start, "newline"))
                        Object.assign(t, { key: null, sep: [this.sourceToken] });
                    else {
                        let r = De(t.start);
                        this.stack.push({ type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: r, key: null, sep: [this.sourceToken] }] });
                    }
                else
                    t.sep ? t.value || n ? e.items.push({ start: i, key: null, sep: [this.sourceToken] }) : Z(t.sep, "map-value-ind") ? this.stack.push({ type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: [], key: null, sep: [this.sourceToken] }] }) : t.sep.push(this.sourceToken) : Object.assign(t, { key: null, sep: [this.sourceToken] });
                this.onKeyLine = !0;
                return;
            case "alias":
            case "scalar":
            case "single-quoted-scalar":
            case "double-quoted-scalar": {
                let r = this.flowScalar(this.type);
                n || t.value ? (e.items.push({ start: i, key: r, sep: [] }), this.onKeyLine = !0) : t.sep ? this.stack.push(r) : (Object.assign(t, { key: r, sep: [] }), this.onKeyLine = !0);
                return;
            }
            default: {
                let r = this.startBlockValue(e);
                if (r) {
                    n && r.type !== "block-seq" && Z(t.start, "explicit-key-ind") && e.items.push({ start: i }), this.stack.push(r);
                    return;
                }
            }
        }
    } yield* this.pop(), yield* this.step(); }
    *blockSequence(e) { let t = e.items[e.items.length - 1]; switch (this.type) {
        case "newline":
            if (t.value) {
                let n = "end" in t.value ? t.value.end : void 0;
                (Array.isArray(n) ? n[n.length - 1] : void 0)?.type === "comment" ? n?.push(this.sourceToken) : e.items.push({ start: [this.sourceToken] });
            }
            else
                t.start.push(this.sourceToken);
            return;
        case "space":
        case "comment":
            if (t.value)
                e.items.push({ start: [this.sourceToken] });
            else {
                if (this.atIndentedComment(t.start, e.indent)) {
                    let i = e.items[e.items.length - 2]?.value?.end;
                    if (Array.isArray(i)) {
                        Array.prototype.push.apply(i, t.start), i.push(this.sourceToken), e.items.pop();
                        return;
                    }
                }
                t.start.push(this.sourceToken);
            }
            return;
        case "anchor":
        case "tag":
            if (t.value || this.indent <= e.indent)
                break;
            t.start.push(this.sourceToken);
            return;
        case "seq-item-ind":
            if (this.indent !== e.indent)
                break;
            t.value || Z(t.start, "seq-item-ind") ? e.items.push({ start: [this.sourceToken] }) : t.start.push(this.sourceToken);
            return;
    } if (this.indent > e.indent) {
        let n = this.startBlockValue(e);
        if (n) {
            this.stack.push(n);
            return;
        }
    } yield* this.pop(), yield* this.step(); }
    *flowCollection(e) { let t = e.items[e.items.length - 1]; if (this.type === "flow-error-end") {
        let n;
        do
            yield* this.pop(), n = this.peek(1);
        while (n && n.type === "flow-collection");
    }
    else if (e.end.length === 0) {
        switch (this.type) {
            case "comma":
            case "explicit-key-ind":
                !t || t.sep ? e.items.push({ start: [this.sourceToken] }) : t.start.push(this.sourceToken);
                return;
            case "map-value-ind":
                !t || t.value ? e.items.push({ start: [], key: null, sep: [this.sourceToken] }) : t.sep ? t.sep.push(this.sourceToken) : Object.assign(t, { key: null, sep: [this.sourceToken] });
                return;
            case "space":
            case "comment":
            case "newline":
            case "anchor":
            case "tag":
                !t || t.value ? e.items.push({ start: [this.sourceToken] }) : t.sep ? t.sep.push(this.sourceToken) : t.start.push(this.sourceToken);
                return;
            case "alias":
            case "scalar":
            case "single-quoted-scalar":
            case "double-quoted-scalar": {
                let i = this.flowScalar(this.type);
                !t || t.value ? e.items.push({ start: [], key: i, sep: [] }) : t.sep ? this.stack.push(i) : Object.assign(t, { key: i, sep: [] });
                return;
            }
            case "flow-map-end":
            case "flow-seq-end":
                e.end.push(this.sourceToken);
                return;
        }
        let n = this.startBlockValue(e);
        n ? this.stack.push(n) : (yield* this.pop(), yield* this.step());
    }
    else {
        let n = this.peek(2);
        if (n.type === "block-map" && (this.type === "map-value-ind" && n.indent === e.indent || this.type === "newline" && !n.items[n.items.length - 1].sep))
            yield* this.pop(), yield* this.step();
        else if (this.type === "map-value-ind" && n.type !== "flow-collection") {
            let i = Pt(n), r = De(i);
            sn(e);
            let o = e.end.splice(1, e.end.length);
            o.push(this.sourceToken);
            let a = { type: "block-map", offset: e.offset, indent: e.indent, items: [{ start: r, key: e, sep: o }] };
            this.onKeyLine = !0, this.stack[this.stack.length - 1] = a;
        }
        else
            yield* this.lineEnd(e);
    } }
    flowScalar(e) {
        if (this.onNewLine) {
            let t = this.source.indexOf(`
`) + 1;
            for (; t !== 0;)
                this.onNewLine(this.offset + t), t = this.source.indexOf(`
`, t) + 1;
        }
        return { type: e, offset: this.offset, indent: this.indent, source: this.source };
    }
    startBlockValue(e) { switch (this.type) {
        case "alias":
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar": return this.flowScalar(this.type);
        case "block-scalar-header": return { type: "block-scalar", offset: this.offset, indent: this.indent, props: [this.sourceToken], source: "" };
        case "flow-map-start":
        case "flow-seq-start": return { type: "flow-collection", offset: this.offset, indent: this.indent, start: this.sourceToken, items: [], end: [] };
        case "seq-item-ind": return { type: "block-seq", offset: this.offset, indent: this.indent, items: [{ start: [this.sourceToken] }] };
        case "explicit-key-ind": {
            this.onKeyLine = !0;
            let t = Pt(e), n = De(t);
            return n.push(this.sourceToken), { type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: n }] };
        }
        case "map-value-ind": {
            this.onKeyLine = !0;
            let t = Pt(e), n = De(t);
            return { type: "block-map", offset: this.offset, indent: this.indent, items: [{ start: n, key: null, sep: [this.sourceToken] }] };
        }
    } return null; }
    atIndentedComment(e, t) { return this.type !== "comment" || this.indent <= t ? !1 : e.every(n => n.type === "newline" || n.type === "space"); }
    *documentEnd(e) { this.type !== "doc-mode" && (e.end ? e.end.push(this.sourceToken) : e.end = [this.sourceToken], this.type === "newline" && (yield* this.pop())); }
    *lineEnd(e) { switch (this.type) {
        case "comma":
        case "doc-start":
        case "doc-end":
        case "flow-seq-end":
        case "flow-map-end":
        case "map-value-ind":
            yield* this.pop(), yield* this.step();
            break;
        case "newline": this.onKeyLine = !1;
        case "space":
        case "comment":
        default: e.end ? e.end.push(this.sourceToken) : e.end = [this.sourceToken], this.type === "newline" && (yield* this.pop());
    } }
};
function rn(s) { let e = s.prettyErrors !== !1; return { lineCounter: s.lineCounter || e && new Oe || null, prettyErrors: e }; }
function os(s, e = {}) { let { lineCounter: t, prettyErrors: n } = rn(e), i = new be(t?.addNewLine), r = new ge(e), o = Array.from(r.compose(i.parse(s))); if (n && t)
    for (let a of o)
        a.errors.forEach(Qe(s, t)), a.warnings.forEach(Qe(s, t)); return o.length > 0 ? o : Object.assign([], { empty: !0 }, r.streamInfo()); }
function Mt(s, e = {}) { let { lineCounter: t, prettyErrors: n } = rn(e), i = new be(t?.addNewLine), r = new ge(e), o = null; for (let a of r.compose(i.parse(s), !0, s.length))
    if (!o)
        o = a;
    else if (o.options.logLevel !== "silent") {
        o.errors.push(new x(a.range.slice(0, 2), "MULTIPLE_DOCS", "Source contains multiple documents; please use YAML.parseAllDocuments()"));
        break;
    } return n && t && (o.errors.forEach(Qe(s, t)), o.warnings.forEach(Qe(s, t))), o; }
function as(s, e, t) { let n; typeof e == "function" ? n = e : t === void 0 && e && typeof e == "object" && (t = e); let i = Mt(s, t); if (!i)
    return null; if (i.warnings.forEach(r => ct(i.options.logLevel, r)), i.errors.length > 0) {
    if (i.options.logLevel !== "silent")
        throw i.errors[0];
    i.errors = [];
} return i.toJS(Object.assign({ reviver: n }, t)); }
function ls(s, e, t) { let n = null; if (typeof e == "function" || Array.isArray(e) ? n = e : t === void 0 && e && (t = e), typeof t == "string" && (t = t.length), typeof t == "number") {
    let i = Math.round(t);
    t = i < 1 ? void 0 : i > 8 ? { indent: 8 } : { indent: i };
} if (s === void 0) {
    let { keepUndefined: i } = t ?? e ?? {};
    if (!i)
        return;
} return new R(s, n, t).toString(t); }
var Vn = cs;
var { Composer: lc, Document: cc, Schema: fc, YAMLError: uc, YAMLParseError: hc, YAMLWarning: pc, Alias: mc, isAlias: dc, isCollection: gc, isDocument: yc, isMap: bc, isNode: wc, isPair: Sc, isScalar: kc, isSeq: Nc, Pair: Ac, Scalar: Oc, YAMLMap: Ec, YAMLSeq: Lc, CST: Tc, Lexer: Ic, LineCounter: Cc, Parser: vc, parse: $c, parseAllDocuments: _c, parseDocument: Pc, stringify: Mc, visit: Bc, visitAsync: Dc } = Bt, { default: on, ...Yn } = Bt, jc = on !== void 0 ? on : Yn;
exports.Composer = lc;
exports.Document = cc;
exports.Schema = fc;
exports.YAMLError = uc;
exports.YAMLParseError = hc;
exports.YAMLWarning = pc;
exports.Alias = mc;
exports.isAlias = dc;
exports.isCollection = gc;
exports.isDocument = yc;
exports.isMap = bc;
exports.isNode = wc;
exports.isPair = Sc;
exports.isScalar = kc;
exports.isSeq = Nc;
exports.Pair = Ac;
exports.Scalar = Oc;
exports.YAMLMap = Ec;
exports.YAMLSeq = Lc;
exports.CST = Tc;
exports.Lexer = Ic;
exports.LineCounter = Cc;
exports.Parser = vc;
exports.parse = $c;
exports.parseAllDocuments = _c;
exports.parseDocument = Pc;
exports.stringify = Mc;
exports.visit = Bc;
exports.visitAsync = Dc;
exports.default = jc;
//# sourceMappingURL=yaml.js.map