import type { PSLiteral, PSValue } from "./types.js";
export declare function read(source: string): PSLiteral<PSValue>;
export declare function isLiteral<T extends PSValue>(value?: T | null): value is PSLiteral<T>;
export declare function derive<T extends PSValue>(parent: T, child: T): T;
